#ifndef _CSP_GLOBAL_REGISTERS_H
#define _CSP_GLOBAL_REGISTERS_H


#ifndef        CSP_GLOBAL_BLOCKBASE_INF
#define    CSP_GLOBAL_BLOCKBASE_INF
#define    BLOCK_CSP_GLOBAL_VERSION 1
#define    BLOCK_CSP_GLOBAL_TIMESTAMP "2019/8/26 14:01:51"
#define    CSP_GLOBAL_BLOCK                                           0x0 
#define    CSP_GLOBAL_REG_START                                       0x0 
#define    CSP_GLOBAL_REG_END_CHX004                                  0x380 
#define    CSP_GLOBAL_REG_LIMIT_CHX004                                0x380 
#define    CSP_GLOBAL_REG_END_Elt3k                                   0x3C0 
#define    CSP_GLOBAL_REG_LIMIT_Elt3k                                 0x3C0 
#endif

#define        Reg_Block_Busy_Bits_Top_Offset                             0x0
#define        Reg_Block_Busy_Bits_Gpc0_0_Offset                          0x1
#define        Reg_Block_Busy_Bits_Gpc0_1_Offset                          0x2
#define        Reg_Block_Busy_Bits_Gpc1_0_Offset                          0x3
#define        Reg_Block_Busy_Bits_Gpc1_1_Offset                          0x4
#define        Reg_Block_Busy_Bits_Gpc2_0_Offset                          0x5
#define        Reg_Block_Busy_Bits_Gpc2_1_Offset                          0x6
#define        Reg_Ring_Buf_Offset                                        0x7
#define        Reg_Preempt_Cmd_Process_Offset                             0x23
#define        Reg_Cpu_Set_Offset                                         0x24
#define        Reg_Fence_Mask_Offset                                      0x25
#define        Reg_Trans_Threshold_Cnt_Offset_CHX004                      0x26
#define        Reg_Reserved_Dw_0_Offset_Elt3k                             0x26
#define        Reg_Pfb_Partition_3d_Cfg_Offset                            0x27
#define        Reg_Pfb_Partition_Cs_Cfg_Offset                            0x28
#define        Reg_Csp_Ms_Total_Gpu_Timestamp_Offset_Elt3k                0x29

#define        Reg_Csp_Ref_Total_Gpu_Timestamp_Offset                     Reg_Csp_Ms_Total_Gpu_Timestamp_Offset_Elt3k
#define        Reg_Csp_Ms_Total_Busy_Time_Offset                          0x2B
#define        Reg_Csp_Ms_Query_Occlusion_Offset                          0x2D
#define        Reg_Csp_Ms_Total_Gpu_Timestamp_Offset_CHX004               0x2F

#define        Reg_Ia_Vertices_Cnt_Offset_Elt3k                           0x2F
#define        Reg_Ia_Primitives_Cnt_Offset_Elt3k                         0x31

#define        Reg_Ia_Ogl_Cut_Flag_32_Offset                              0x33
#define        Reg_Ia_Vb0_Offset_Offset                                   0x34
#define        Reg_Ia_Vb0_Stride_Offset                                   0x35
#define        Reg_Ia_Bufferfilledsize_Offset                             0x36
#define        Reg_Ia_Batch_Cfg_Offset                                    0x37
#define        Reg_Predicate_Status_Offset                                0x38
#define        Reg_Csp_Misc_Control_Offset                                0x39

#define        Reg_Index_Buf_Fmt_Enum_Offset_CHX004                       0x3A
#define        Reg_Ia_Input_Vertices_Cnt_Offset_CHX004                    0x3B
#define        Reg_Ia_Output_Vertices_Cnt_Offset_CHX004                   0x3D
#define        Reg_Ia_Primitives_Cnt_Offset_CHX004                        0x3F
#define        Reg_Csp_Skip_2_Offset_CHX004                               0x41

#define        Reg_Tbr_Render_Mode_Ctrl_Offset_Elt3k                      0x3A
#define        Reg_Tbr_Frametimestamp_Lth_Offset_Elt3k                    0x3B
#define        Reg_Tbr_Frametimestamp_Hth_Offset_Elt3k                    0x3C
#define        Reg_Tbr_Traffic_Th_Offset_Elt3k                            0x3D
#define        Reg_Tbr_Event_Count_Ref_Offset_Elt3k                       0x3E
#define        Reg_Descriptor_Base_Addr_Offset_Elt3k                      0x3F

#define        Reg_Csp_Fence_Counter_Offset                               0x47
#define        Reg_Ila_Counters_Offset                                    0x57
#define        Reg_Gpc_Signature_Offset                                   0x7F
#define        Reg_Sto_Signature_Offset                                   0xE5
#define        Reg_Csp_Slice_Status_Offset                                0xED
#define        Reg_Cur_L1_Dma_Cmd_Offset                                  0xEE
#define        Reg_Cur_L2_Dma_Cmd_Offset                                  0xEF
#define        Reg_Cur_3d_Rbuf_Cmd_Offset                                 0xF0
#define        Reg_Cur_3d_Hrbuf_Cmd_Offset                                0xF1
#define        Reg_Cur_Csh_Rbuf_Cmd_Offset                                0xF2
#define        Reg_Cur_Cs0_Rbuf_Cmd_Offset                                0xF3
#define        Reg_Cur_Cs1_Rbuf_Cmd_Offset                                0xF4
#define        Reg_Cur_Cs2_Rbuf_Cmd_Offset                                0xF5
#define        Reg_Cur_Cs3_Rbuf_Cmd_Offset                                0xF6
#define        Reg_U_Fence_Num_Ctrl_Offset                                0xF7
#define        Reg_Csp_Skip_3_Offset                                      0xF8

#define        Reg_C3d_Eng_Workload_Offset_Elt3k                          0xF7
#define        Reg_C3d_Eng_Alu_Workload_Offset_Elt3k                      0xF8

#define        Reg_C3d_Mem_Workload_Offset_Elt3k                          0xF9
#define        Reg_Vpp_Workload_Offset_Elt3k                              0xFA
#define        Reg_Vcp0_Workload_Offset_Elt3k                             0xFB
#define        Reg_Vcp1_Workload_Offset_Elt3k                             0xFC
#define        Reg_Csp_Skip0_Offset_Elt3k                                 0xFD

#define        Reg_Reg_Dvfs_Cfg_En_Offset                                 0x100
#define        Reg_Reg_Dvfs_Cfg_Misc0_Offset                              0x101
#define        Reg_Reg_3d_Dvfs_Checksize_Offset                           0x102
#define        Reg_Reg_3d_Dvfs_H_Th_Offset                                0x103
#define        Reg_Reg_3d_Dvfs_L_Th_Offset                                0x104
#define        Reg_Reg_3d_Dvfs_H_Th_Mem_Offset                            0x105
#define        Reg_Reg_3d_Alu_Workload_Offset                             0x106
#define        Reg_Reg_3d_Busy_Workload_Offset                            0x107
#define        Reg_Reg_Vcp0_Dvfs_Checksize_Offset                         0x108
#define        Reg_Reg_Vcp0_Dvfs_H_Th_Offset                              0x109
#define        Reg_Reg_Vcp0_Dvfs_L_Th_Offset                              0x10A
#define        Reg_Reg_Vcp0_Dvfs_H_Th_Mem_Offset                          0x10B
#define        Reg_Reg_Vcp0_Busy_Cycle_Offset                             0x10C
#define        Reg_Reg_Vcp1_Dvfs_Checksize_Offset                         0x10D
#define        Reg_Reg_Vcp1_Dvfs_H_Th_Offset                              0x10E
#define        Reg_Reg_Vcp1_Dvfs_L_Th_Offset                              0x10F
#define        Reg_Reg_Vcp1_Dvfs_H_Th_Mem_Offset                          0x110
#define        Reg_Reg_Vcp1_Busy_Cycle_Offset                             0x111
#define        Reg_Reg_Vpp_Dvfs_Checksize_Offset                          0x112
#define        Reg_Reg_Vpp_Dvfs_H_Th_Offset                               0x113
#define        Reg_Reg_Vpp_Dvfs_L_Th_Offset                               0x114
#define        Reg_Reg_Vpp_Dvfs_H_Th_Mem_Offset                           0x115
#define        Reg_Reg_Vpp_Busy_Cycle_Offset                              0x116
#define        Reg_Reg_Dvfs_Pcu_Cfg_En_Offset                             0x117
#define        Reg_Reg_3d_Mem_Busy_Cycle_Offset                           0x118
#define        Reg_Reg_Vcp0_Mem_Busy_Cycle_Offset                         0x119
#define        Reg_Reg_Vcp1_Mem_Busy_Cycle_Offset                         0x11A
#define        Reg_Reg_Vpp_Mem_Busy_Cycle_Offset                          0x11B
#define        Reg_Pwr_Mgr_Cfg_En_Offset                                  0x11C
#define        Reg_Pwr_Mgr_Pg_Pd_Misc0_Offset                             0x11D
#define        Reg_Pwr_Mgr_Pg_Pd_Misc1_Offset                             0x11E
#define        Reg_Pwr_Mgr_Pg_Pd_Misc2_Offset                             0x11F
#define        Reg_Pwr_Mgr_Pg_Pu_Misc0_Offset                             0x120
#define        Reg_Pwr_Mgr_Pg_Pu_Misc1_Offset                             0x121
#define        Reg_Pwr_Mgr_Pg_Pu_Misc2_Offset                             0x122
#define        Reg_Pwr_Mgr_Wait_3d_Cnt0_Offset                            0x123
#define        Reg_Pwr_Mgr_Wait_S3vd_Cnt1_Offset                          0x124
#define        Reg_Pwr_Mgr_Wait_Vpp_Cnt2_Offset                           0x125
#define        Reg_Pwr_Mgr_Wait_Mxu0_Cnt3_Offset                          0x126
#define        Reg_Pwr_Mgr_Sw_Cfg_En_Offset                               0x127
#define        Reg_Pwr_Mgr_Sw_Cfg0_Offset                                 0x128
#define        Reg_Pwr_Mgr_Status0_Offset                                 0x129
#define        Reg_Pwr_Mgr_Status1_Offset                                 0x12A
#define        Reg_Csp_Skip_4_Offset                                      0x12B
#define        Reg_Pwr_Ts_Cfg_En_Offset                                   0x140
#define        Reg_Pwr_Ts_Cfg_Misc0_Offset                                0x141
#define        Reg_Pwr_Ts_Cfg_Misc1_Offset                                0x142
#define        Reg_Pwr_Ts_Cfg_Misc2_Offset                                0x143
#define        Reg_Pwr_Ts_Cfg_Misc3_Offset                                0x144
#define        Reg_Pwr_Ts_Cfg_Misc4_Offset                                0x145
#define        Reg_Pwr_Ts_Cfg_Misc5_Offset                                0x146
#define        Reg_Pwr_Ts_Cfg_Misc6_Offset                                0x147
#define        Reg_Pwr_Ts_Cfg_Misc7_Offset                                0x148
#define        Reg_Csp_Skip_5_Offset                                      0x149

#define        Reg_Vcp_Ring_Buf_Offset                                    0x180
#define        Reg_Vpp_Ring_Buf_Offset                                    0x188
#define        Reg_Vcp_Vpp_Block_Busy_Bits_Offset                         0x18C
#define        Reg_Csp_Skip1_Offset                                       0x18D
#define        Reg_Cmodel_Dma_Preemption_Begin_Offset                     0x1FC
#define        Reg_Cmodel_Dma_Preemption_Cnt_Offset                       0x1FD
#define        Reg_Cmodel_Dma_Preemption_Tail_Offset                      0x1FE
#define        Reg_Cmodel_Hl_Switch_Offset                                0x1FF
#define        Reg_Eu_Dbg_Reg_Offset                                      0x200

#ifndef CHOOSE_REG_OFFSET_BY_CHIP
#define CHOOSE_REG_OFFSET_BY_CHIP(bElt3k,offset)  ((bElt3k) ? offset##_Elt3k : offset##_CHX004)
#endif

#define Reg_Csp_Ms_Total_Gpu_Timestamp_Offset                           Reg_Csp_Ms_Total_Gpu_Timestamp_Offset_CHX004

typedef enum
{
	CSP_MISC_CONTROL_PROVOKEMODE_FIRST_VTX = 0,   
	CSP_MISC_CONTROL_PROVOKEMODE_LAST_VTX = 1,   
} CSP_MISC_CONTROL_PROVOKEMODE;
typedef enum
{
	CMODEL_HL_SWITCH_CMD_TYPE_NO_SWITCH = 0,   
	CMODEL_HL_SWITCH_CMD_TYPE_DIP = 1,
	CMODEL_HL_SWITCH_CMD_TYPE_GP = 2,
	CMODEL_HL_SWITCH_CMD_TYPE_FAST_CLEAR = 3,
	CMODEL_HL_SWITCH_CMD_TYPE_BIT_BLT = 4,
	CMODEL_HL_SWITCH_CMD_TYPE_IMAGE_TRANSFER = 5,
	CMODEL_HL_SWITCH_CMD_TYPE_INDICATOR_OFF = 6,
} CMODEL_HL_SWITCH_CMD_TYPE;
typedef enum
{
	EU_DBG_CFG_EXEC_EN_DISABLED = 0,   
									   EU_DBG_CFG_EXEC_EN_ENABLED = 1,   
} EU_DBG_CFG_EXEC_EN;
typedef enum
{
	EU_DBG_CFG_TH_MODE_SINGLE = 0,   
									 EU_DBG_CFG_TH_MODE_ALL = 1,   
} EU_DBG_CFG_TH_MODE;
typedef enum
{
	EU_DBG_CFG_INT_EN_DISABLED = 0,   
									  EU_DBG_CFG_INT_EN_ENABLED = 1,   
} EU_DBG_CFG_INT_EN;
typedef enum
{
	EU_DBG_CFG_RES_EN_DISABLED = 0,   
									  EU_DBG_CFG_RES_EN_ENABLED = 1,   
} EU_DBG_CFG_RES_EN;
typedef enum
{
	EU_DBG_BP_STAT_BP_HIT_DISABLED = 0,   
										  EU_DBG_BP_STAT_BP_HIT_ENABLED = 1,   
} EU_DBG_BP_STAT_BP_HIT;
typedef enum
{
	EU_DBG_BP_PC_BP_VALID_DISABLED = 0,   
	EU_DBG_BP_PC_BP_VALID_ENABLED = 1,   
} EU_DBG_BP_PC_BP_VALID;
typedef enum
{
	EU_DBG_BP_PC_SHADER_VS = 0,
	EU_DBG_BP_PC_SHADER_HS = 1,
	EU_DBG_BP_PC_SHADER_DS = 2,
	EU_DBG_BP_PC_SHADER_GS = 3,
	EU_DBG_BP_PC_SHADER_PS = 4,
	EU_DBG_BP_PC_SHADER_CS = 5,
} EU_DBG_BP_PC_SHADER;


#define Reg_BLOCK_BUSY_BITS_TOP_Csp_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Mxua_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Mxub_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_L2_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Gpcpfe_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Gpcpbe_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Sg_Busy_BitField_MaxValue ((1u << 3) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Tasfe_Busy_BitField_MaxValue ((1u << 3) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Tasbe_Busy_BitField_MaxValue ((1u << 3) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Hub_Busy_BitField_MaxValue ((1u << 3) - 1)
#define Reg_BLOCK_BUSY_BITS_TOP_Reserved_BitField_MaxValue ((1u << 14) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Csp_Busy : 1;
		unsigned int Mxua_Busy : 1;
		unsigned int Mxub_Busy : 1;
		unsigned int L2_Busy : 1;
		unsigned int Gpcpfe_Busy : 1;
		unsigned int Gpcpbe_Busy : 1;
		unsigned int Sg_Busy : 3;
		unsigned int Tasfe_Busy : 3;
		unsigned int Tasbe_Busy : 3;
		unsigned int Hub_Busy : 3;
		unsigned int Reserved : 13;
		unsigned int EngineHang : 1;
	} reg;
} Reg_Block_Busy_Bits_Top;

#define Reg_BLOCK_BUSY_BITS_GPC0_0_Tgz_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Iu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Wbu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Wls_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Ffc_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Tu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_0_Reserved_BitField_MaxValue ((1u << 8) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Tgz_Busy : 4;
		unsigned int Iu_Busy : 4;
		unsigned int Wbu_Busy : 4;
		unsigned int Wls_Busy : 4;
		unsigned int Ffc_Busy : 4;
		unsigned int Tu_Busy : 4;
		unsigned int Reserved : 8;
	} reg;
} Reg_Block_Busy_Bits_Gpc0_0;

#define Reg_BLOCK_BUSY_BITS_GPC0_1_Eu_Constructor_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Euvs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Euhs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Eufe_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Euds_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Eugs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Eups_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC0_1_Eucs_Busy_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Eu_Constructor_Busy : 4;   
		unsigned int Euvs_Busy : 4;
		unsigned int Euhs_Busy : 4;
		unsigned int Eufe_Busy : 4;
		unsigned int Euds_Busy : 4;
		unsigned int Eugs_Busy : 4;
		unsigned int Eups_Busy : 4;
		unsigned int Eucs_Busy : 4;
	} reg;
} Reg_Block_Busy_Bits_Gpc0_1;

#define Reg_BLOCK_BUSY_BITS_GPC1_0_Tgz_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Iu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Wbu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Wls_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Ffc_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Tu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_0_Reserved_BitField_MaxValue ((1u << 8) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Tgz_Busy : 4;
		unsigned int Iu_Busy : 4;
		unsigned int Wbu_Busy : 4;
		unsigned int Wls_Busy : 4;
		unsigned int Ffc_Busy : 4;
		unsigned int Tu_Busy : 4;
		unsigned int Reserved : 8;
	} reg;
} Reg_Block_Busy_Bits_Gpc1_0;

#define Reg_BLOCK_BUSY_BITS_GPC1_1_Eu_Constructor_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Euvs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Euhs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Eufe_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Euds_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Eugs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Eups_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC1_1_Eucs_Busy_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Eu_Constructor_Busy : 4;   
		unsigned int Euvs_Busy : 4;
		unsigned int Euhs_Busy : 4;
		unsigned int Eufe_Busy : 4;
		unsigned int Euds_Busy : 4;
		unsigned int Eugs_Busy : 4;
		unsigned int Eups_Busy : 4;
		unsigned int Eucs_Busy : 4;
	} reg;
} Reg_Block_Busy_Bits_Gpc1_1;

#define Reg_BLOCK_BUSY_BITS_GPC2_0_Tgz_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Iu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Wbu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Wls_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Ffc_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Tu_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_0_Reserved_BitField_MaxValue ((1u << 8) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Tgz_Busy : 4;
		unsigned int Iu_Busy : 4;
		unsigned int Wbu_Busy : 4;
		unsigned int Wls_Busy : 4;
		unsigned int Ffc_Busy : 4;
		unsigned int Tu_Busy : 4;
		unsigned int Reserved : 8;
	} reg;
} Reg_Block_Busy_Bits_Gpc2_0;

#define Reg_BLOCK_BUSY_BITS_GPC2_1_Eu_Constructor_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Euvs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Euhs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Eufe_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Euds_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Eugs_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Eups_Busy_BitField_MaxValue ((1u << 4) - 1)
#define Reg_BLOCK_BUSY_BITS_GPC2_1_Eucs_Busy_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Eu_Constructor_Busy : 4;   
		unsigned int Euvs_Busy : 4;
		unsigned int Euhs_Busy : 4;
		unsigned int Eufe_Busy : 4;
		unsigned int Euds_Busy : 4;
		unsigned int Eugs_Busy : 4;
		unsigned int Eups_Busy : 4;
		unsigned int Eucs_Busy : 4;
	} reg;
} Reg_Block_Busy_Bits_Gpc2_1;

#define Reg_RUN_LIST_CTX_ADDR1_Addr_BitField_MaxValue ((1u << 28) - 1)
#define Reg_RUN_LIST_CTX_ADDR1_L2_Cachable_BitField_MaxValue ((1u << 1) - 1)
#define Reg_RUN_LIST_CTX_ADDR1_Reserved_BitField_MaxValue ((1u << 2) - 1)
#define Reg_RUN_LIST_CTX_ADDR1_Kickoff_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Addr : 28;  
		unsigned int L2_Cachable : 1;   
		unsigned int Reserved : 2;
		unsigned int Kickoff : 1;   
	} reg;
} Reg_Run_List_Ctx_Addr1;

#define Reg_RING_BUF_SIZE_Rb_Size_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Size : 32;  
	} reg;
} Reg_Ring_Buf_Size;

#define Reg_RING_BUF_HEAD_Rb_Head_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Head : 32;  
	} reg;
} Reg_Ring_Buf_Head;

#define Reg_RING_BUF_TAIL_Rb_Tail_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Tail : 32;  
	} reg;
} Reg_Ring_Buf_Tail;

typedef struct _Group_Ring_Buf
{
	Reg_Run_List_Ctx_Addr1           reg_Run_List_Ctx_Addr1;
	Reg_Ring_Buf_Size                reg_Ring_Buf_Size;
	Reg_Ring_Buf_Head                reg_Ring_Buf_Head;
	Reg_Ring_Buf_Tail                reg_Ring_Buf_Tail;
} Reg_Ring_Buf_Group;

#define Reg_PREEMPT_CMD_PROCESS_Preempt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PREEMPT_CMD_PROCESS_Reserved_BitField_MaxValue ((1u << 31) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Preempt : 1;   
		unsigned int Reserved : 31;
	} reg;
} Reg_Preempt_Cmd_Process;

#define Reg_CPU_SET_Cpu_Set_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CPU_SET_Reserved_BitField_MaxValue ((1u << 31) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Cpu_Set : 1;   
		unsigned int Reserved : 31;
	} reg;
} Reg_Cpu_Set;

#define Reg_FENCE_MASK_Mask_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Mask : 32;  
	} reg;
} Reg_Fence_Mask;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Counter : 20;
        unsigned int Reesrved : 12;
    } reg;
} Reg_Trans_Threshold_Cnt;

#define Reg_PFB_PARTITION_3D_CFG_Lrb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_L1dma_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_L2dma_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_L1buf_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_Lib_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_Hrb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_Hl1buf_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_3D_CFG_Hib_Size_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reesrved                  : 32; 
    } reg;
} Reg_Reserved_Dw_0;

#define Reg_PFB_PARTITION_CS_CFG_Csh_Rb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_Csl0_Rb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_Csl1_Rb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_Csl2_Rb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_Csl3_Rb_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_L1dma_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_L2dma_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PFB_PARTITION_CS_CFG_Csl_L1buf_Size_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Lrb_Size : 4;   
		unsigned int L1dma_Size : 4;   
		unsigned int L2dma_Size : 4;   
		unsigned int L1buf_Size : 4;   
		unsigned int Lib_Size : 4;   
		unsigned int Hrb_Size : 4;   
		unsigned int Hl1buf_Size : 4;   
		unsigned int Hib_Size : 4;   
	} reg;
} Reg_Pfb_Partition_3d_Cfg;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Csh_Rb_Size : 4;
		unsigned int Csl0_Rb_Size : 4;
		unsigned int Csl1_Rb_Size : 4;
		unsigned int Csl2_Rb_Size : 4;
		unsigned int Csl3_Rb_Size : 4;
		unsigned int L1dma_Size : 4;   
		unsigned int L2dma_Size : 4;   
		unsigned int Csl_L1buf_Size : 4;
	} reg;
} Reg_Pfb_Partition_Cs_Cfg;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Csp_Ref_Total_Gpu_Timestamp;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Csp_Ms_Total_Busy_Time;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Csp_Ms_Query_Occlusion;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Ms_Total_Gpu_Timestamp;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Ia_Vertices_Cnt;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Ia_Primitives_Cnt;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Csp_Skip_1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ufence_Total_Num : 8;   
        unsigned int Reserved : 24;
    } reg;
} Reg_U_Fence_Num_Ctrl;

#define Reg_IA_OGL_CUT_FLAG_32_Ogl_Cut_Flag_32_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Ogl_Cut_Flag_32 : 32;  
	} reg;
} Reg_Ia_Ogl_Cut_Flag_32;

#define Reg_IA_VB0_OFFSET_Offset_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Offset : 32;
	} reg;
} Reg_Ia_Vb0_Offset;

#define Reg_IA_VB0_STRIDE_Stride_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Stride : 32;
	} reg;
} Reg_Ia_Vb0_Stride;

#define Reg_IA_BUFFERFILLEDSIZE_Bufferfilledsize_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Bufferfilledsize : 32;  
	} reg;
} Reg_Ia_Bufferfilledsize;

#define Reg_IA_BATCH_CFG_Batchprimnum_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Batchprimnum : 32;  
	} reg;
} Reg_Ia_Batch_Cfg;

#define Reg_PREDICATE_STATUS_Predicate_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PREDICATE_STATUS_Reserved_BitField_MaxValue ((1u << 31) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Predicate_En : 1;   
		unsigned int Reserved : 31;
	} reg;
} Reg_Predicate_Status;

#define Reg_CSP_MISC_CONTROL_Triangle_Cut_Index_Enable_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Gs_On_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Ila_Mode_BitField_MaxValue ((1u << 4) - 1)
#define Reg_CSP_MISC_CONTROL_Fe_Cnt_Disable_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Ila_Gpc_Sel_BitField_MaxValue ((1u << 2) - 1)
#define Reg_CSP_MISC_CONTROL_Leading_Vtx_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Dump_3d_Signature_Zero_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Flat_Quad_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CSP_MISC_CONTROL_Reserved1_BitField_MaxValue ((1u << 20) - 1)

typedef union
{
	unsigned int uint;
    struct
    {
        unsigned int Triangle_Cut_Index_Enable : 1;   
        unsigned int Gs_On : 1;   
        unsigned int Ila_Mode : 4;   
        unsigned int Fe_Cnt_Disable : 1;   
        unsigned int Ila_Gpc_Sel : 2;   
        unsigned int Provokemode : 1;   
        unsigned int Dump_3d_Signature_Zero : 1;   
        unsigned int Flat_Quad : 1;   
        unsigned int Reserved1 : 20;
    } reg;
} Reg_Csp_Misc_Control;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Render_Mode_Switch_En     : 1; 
        unsigned int Render_Mode               : 1;   
        unsigned int Render_Irq_Mode           : 1;   
        unsigned int Event_Counter_Reset       : 1;   
        unsigned int Frame_Begin               : 1;   
        unsigned int Frame_End                 : 1;   
        unsigned int Reserved1                 : 10; 
        unsigned int Frame_Check_Window        : 16;  
    } reg;
} Reg_Tbr_Render_Mode_Ctrl;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Frametimestamp_Low_Threshold : 32;
    } reg;
} Reg_Tbr_Frametimestamp_Lth;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Frametimestamp_High_Threshold : 32;
    } reg;
} Reg_Tbr_Frametimestamp_Hth;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Traffic_Threshold         : 32;  
    } reg;
} Reg_Tbr_Traffic_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Tbr_Irq_Ref               : 16;  
        unsigned int Imr_Irq_Ref               : 16;  
    } reg;
} Reg_Tbr_Event_Count_Ref;

#define Reg_INDEX_BUF_FMT_ENUM_Enum_Ib8_BitField_MaxValue ((1u << 10) - 1)
#define Reg_INDEX_BUF_FMT_ENUM_Enum_Ib16_BitField_MaxValue ((1u << 10) - 1)
#define Reg_INDEX_BUF_FMT_ENUM_Enum_Ib32_BitField_MaxValue ((1u << 10) - 1)
#define Reg_INDEX_BUF_FMT_ENUM_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Enum_Ib8 : 10;  
		unsigned int Enum_Ib16 : 10;  
		unsigned int Enum_Ib32 : 10;  
		unsigned int Reserved : 2;
	} reg;
} Reg_Index_Buf_Fmt_Enum;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Ia_Input_Vertices_Cnt;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Ia_Output_Vertices_Cnt;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Base_Addr;

typedef struct _Group_Descriptor_Base_Addr
{
	Reg_Base_Addr                    reg_Base_Addr;
} Reg_Descriptor_Base_Addr_Group;

#define Reg_FENCE_COUNTER_Counter0_BitField_MaxValue ((1u << 16) - 1)
#define Reg_FENCE_COUNTER_Counter1_BitField_MaxValue ((1u << 16) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Counter0 : 16;
		unsigned int Counter1 : 16;
	} reg;
} Reg_Fence_Counter;

typedef struct _Group_Csp_Fence_Counter
{
	Reg_Fence_Counter                reg_Fence_Counter;
} Reg_Csp_Fence_Counter_Group;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Ila_Counters;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Sg_Sig_Low;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Sg_Sig_High;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_Low_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_High_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_Low_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_High_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_Low_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_High_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_Low_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_D_Sig_High_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_Low_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_High_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_Low_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_High_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_Low_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_High_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_Low_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Z_Sig_High_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_Low_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_High_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_Low_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_High_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_Low_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_High_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_Low_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_U_Sig_High_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_Low_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_High_S0;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_Low_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_High_S1;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_Low_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_High_S2;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_Low_S3;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Eu_Sig_High_S3;

typedef struct _Group_Gpc_Signature
{
	Reg_Sg_Sig_Low                   reg_Sg_Sig_Low;
	Reg_Sg_Sig_High                  reg_Sg_Sig_High;
	Reg_D_Sig_Low_S0                 reg_D_Sig_Low_S0;
	Reg_D_Sig_High_S0                reg_D_Sig_High_S0;
	Reg_D_Sig_Low_S1                 reg_D_Sig_Low_S1;
	Reg_D_Sig_High_S1                reg_D_Sig_High_S1;
	Reg_D_Sig_Low_S2                 reg_D_Sig_Low_S2;
	Reg_D_Sig_High_S2                reg_D_Sig_High_S2;
	Reg_D_Sig_Low_S3                 reg_D_Sig_Low_S3;
	Reg_D_Sig_High_S3                reg_D_Sig_High_S3;
	Reg_Z_Sig_Low_S0                 reg_Z_Sig_Low_S0;
	Reg_Z_Sig_High_S0                reg_Z_Sig_High_S0;
	Reg_Z_Sig_Low_S1                 reg_Z_Sig_Low_S1;
	Reg_Z_Sig_High_S1                reg_Z_Sig_High_S1;
	Reg_Z_Sig_Low_S2                 reg_Z_Sig_Low_S2;
	Reg_Z_Sig_High_S2                reg_Z_Sig_High_S2;
	Reg_Z_Sig_Low_S3                 reg_Z_Sig_Low_S3;
	Reg_Z_Sig_High_S3                reg_Z_Sig_High_S3;
	Reg_U_Sig_Low_S0                 reg_U_Sig_Low_S0;
	Reg_U_Sig_High_S0                reg_U_Sig_High_S0;
	Reg_U_Sig_Low_S1                 reg_U_Sig_Low_S1;
	Reg_U_Sig_High_S1                reg_U_Sig_High_S1;
	Reg_U_Sig_Low_S2                 reg_U_Sig_Low_S2;
	Reg_U_Sig_High_S2                reg_U_Sig_High_S2;
	Reg_U_Sig_Low_S3                 reg_U_Sig_Low_S3;
	Reg_U_Sig_High_S3                reg_U_Sig_High_S3;
	Reg_Eu_Sig_Low_S0                reg_Eu_Sig_Low_S0;
	Reg_Eu_Sig_High_S0               reg_Eu_Sig_High_S0;
	Reg_Eu_Sig_Low_S1                reg_Eu_Sig_Low_S1;
	Reg_Eu_Sig_High_S1               reg_Eu_Sig_High_S1;
	Reg_Eu_Sig_Low_S2                reg_Eu_Sig_Low_S2;
	Reg_Eu_Sig_High_S2               reg_Eu_Sig_High_S2;
	Reg_Eu_Sig_Low_S3                reg_Eu_Sig_Low_S3;
	Reg_Eu_Sig_High_S3               reg_Eu_Sig_High_S3;
} Reg_Gpc_Signature_Group;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Sto_Sig_Low;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Sto_Sig_High;

typedef struct _Group_Sto_Signature
{
	Reg_Sto_Sig_Low                  reg_Sto_Sig_Low;
	Reg_Sto_Sig_High                 reg_Sto_Sig_High;
} Reg_Sto_Signature_Group;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Slice_Mask : 16;  
		unsigned int Reserved1 : 16;
	} reg;
} Reg_Csp_Slice_Status;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_L1_Dma_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_L2_Dma_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_3d_Rbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_3d_Hrbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_Csh_Rbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_Cs0_Rbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_Cs1_Rbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_Cs2_Rbuf_Cmd;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Cur_Cs3_Rbuf_Cmd;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Skip_3;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Dvfs_3d_Auto_En : 1;   
        unsigned int Dvfs_Vcp0_Auto_En : 1;   
        unsigned int Dvfs_Vcp1_Auto_En : 1;   
        unsigned int Dvfs_Vpp_Auto_En : 1;   
        unsigned int Reg_Memory_Dvfs_En : 1;   
        unsigned int Reserved : 27;  
    } reg;
} Reg_Reg_Dvfs_Cfg_En;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Dvfs_3d_Cnt_Mode : 2;   
        unsigned int Dvfs_3d_Cnt_Mux : 1;   
        unsigned int Dvfs_3d_Output_Mode : 2;   
        unsigned int Dvfs_3d_M2m_Dvfs_En : 1;   
        unsigned int Dvfs_3d_M2e_Ratio : 3;   
        unsigned int Dvfs_Vcp0_M2m_Dvfs_En : 1;   
        unsigned int Dvfs_Vcp0_M2e_Ratio : 3;   
        unsigned int Dvfs_Vcp0_Output_Mode : 2;   
        unsigned int Dvfs_Vcp1_M2m_Dvfs_En : 1;   
        unsigned int Dvfs_Vcp1_M2e_Ratio : 3;   
        unsigned int Dvfs_Vcp1_Output_Mode : 2;   
        unsigned int Dvfs_Vpp_M2m_Dvfs_En : 1;   
        unsigned int Dvfs_Vpp_M2e_Ratio : 3;   
        unsigned int Dvfs_Vpp_Output_Mode : 2;   
        unsigned int Reserved : 5;   
    } reg;
} Reg_Reg_Dvfs_Cfg_Misc0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Check_Size_3d : 32;
    } reg;
} Reg_Reg_3d_Dvfs_Checksize;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int High_Workload_Threshold_3d : 32;
    } reg;
} Reg_Reg_3d_Dvfs_H_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Low_Workload_Threshold_3d : 32;
    } reg;
} Reg_Reg_3d_Dvfs_L_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Mem_Busy_Threshold_3d : 32;
    } reg;
} Reg_Reg_3d_Dvfs_H_Th_Mem;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Alu_Workload_3d : 32;
    } reg;
} Reg_Reg_3d_Alu_Workload;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Busy_Workload_3d : 32;
    } reg;
} Reg_Reg_3d_Busy_Workload;
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Check_Size_Vcp0 : 32;
    } reg;
} Reg_Reg_Vcp0_Dvfs_Checksize;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int High_Workload_Threshold_Vcp0 : 32;
    } reg;
} Reg_Reg_Vcp0_Dvfs_H_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Low_Workload_Threshold_Vcp0 : 32;
    } reg;
} Reg_Reg_Vcp0_Dvfs_L_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Mem_Busy_Threshold_Vcp0 : 32;
    } reg;
} Reg_Reg_Vcp0_Dvfs_H_Th_Mem;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Vcp0_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vcp0_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Check_Size_Vcp1 : 32;
    } reg;
} Reg_Reg_Vcp1_Dvfs_Checksize;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int High_Workload_Threshold_Vcp1 : 32;
    } reg;
} Reg_Reg_Vcp1_Dvfs_H_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Low_Workload_Threshold_Vcp1 : 32;
    } reg;
} Reg_Reg_Vcp1_Dvfs_L_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Mem_Busy_Threshold_Vcp1 : 32;
    } reg;
} Reg_Reg_Vcp1_Dvfs_H_Th_Mem;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Vcp1_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vcp1_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Check_Size_Vpp : 32;
    } reg;
} Reg_Reg_Vpp_Dvfs_Checksize;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int High_Workload_Threshold_Vpp : 32;
    } reg;
} Reg_Reg_Vpp_Dvfs_H_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Low_Workload_Threshold_Vpp : 32;
    } reg;
} Reg_Reg_Vpp_Dvfs_L_Th;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Mem_Busy_Threshold_Vpp : 32;
    } reg;
} Reg_Reg_Vpp_Dvfs_H_Th_Mem;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Vpp_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vpp_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reg_Pcu_3d_Dvfs_En : 1;
        unsigned int Reg_Force_3d_Inc_Dfvs : 1;   
        unsigned int Reg_Force_3d_Dec_Dfvs : 1;   
        unsigned int Reg_Pcu_Vcp0_Dvfs_En : 1;
        unsigned int Reg_Force_Vcp0_Inc_Dfvs : 1;   
        unsigned int Reg_Force_Vcp0_Dec_Dfvs : 1;   
        unsigned int Reg_Pcu_Vcp1_Dvfs_En : 1;
        unsigned int Reg_Force_Vcp1_Inc_Dfvs : 1;   
        unsigned int Reg_Force_Vcp1_Dec_Dfvs : 1;   
        unsigned int Reg_Pcu_Vpp_Dvfs_En : 1;
        unsigned int Reg_Force_Vpp_Inc_Dfvs : 1;   
        unsigned int Reg_Force_Vpp_Dec_Dfvs : 1;   
        unsigned int Reserved : 20;  
    } reg;
} Reg_Reg_Dvfs_Pcu_Cfg_En;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Memory_Busy_Cnt : 32;
    } reg;
} Reg_Reg_3d_Mem_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Memory_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vcp0_Mem_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Memory_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vcp1_Mem_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Memory_Busy_Cnt : 32;
    } reg;
} Reg_Reg_Vpp_Mem_Busy_Cycle;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int En_Clkgate_3d_Central : 1;   
        unsigned int En_Clkgate_3d_Slc0 : 1;   
        unsigned int En_Clkgate_3d_Slc1 : 1;   
        unsigned int En_Clkgate_S3vd0 : 1;   
        unsigned int En_Clkgate_S3vd1 : 1;   
        unsigned int En_Clkgate_Vpp : 1;   
        unsigned int En_Clkgate_Mxu0 : 1;   
        unsigned int En_Pwrgate_3d_Central : 1;   
        unsigned int En_Pwrgate_3d_Slc0 : 1;   
        unsigned int En_Pwrgate_3d_Slc1 : 1;   
        unsigned int En_Pwrgate_S3vd0 : 1;   
        unsigned int En_Pwrgate_S3vd1 : 1;   
        unsigned int En_Pwrgate_Vpp : 1;   
        unsigned int Reserved : 16;  
        unsigned int Fast_Boot_En : 1;   
        unsigned int Be_Mode : 1;   
        unsigned int Grout_Reset_Enable : 1;   
    } reg;
} Reg_Pwr_Mgr_Cfg_En;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Pd_Isoon_Pwroff_3d : 8;   
        unsigned int Cnt_Pd_Isoon_Pwroff_S3vd : 8;    
        unsigned int Cnt_Pd_Isoon_Pwroff_Vpp : 8;   
        unsigned int Reserved : 8;   
    } reg;
} Reg_Pwr_Mgr_Pg_Pd_Misc0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Pd_Complete_3d : 16;  
        unsigned int Cnt_Pd_Complete_S3vd : 16;  
    } reg;
} Reg_Pwr_Mgr_Pg_Pd_Misc1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Pd_Complete_Vpp : 16;  
        unsigned int Reserved : 16;  
    } reg;
} Reg_Pwr_Mgr_Pg_Pd_Misc2;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Wakeup_Rston_3d : 16;  
        unsigned int Cnt_Wakeup_Rston_S3vd : 16;  
    } reg;
} Reg_Pwr_Mgr_Pg_Pu_Misc0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Wakeup_Rston_Vpp : 16;  
        unsigned int Reserved : 16;  
    } reg;
} Reg_Pwr_Mgr_Pg_Pu_Misc1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cnt_Rston_Clkon : 8;   
        unsigned int Cnt_Clkon_Rstoff : 8;   
        unsigned int Cnt_Rstoff_Isooff : 8;   
        unsigned int Cnt_Isooff_Ready : 8;   
    } reg;
} Reg_Pwr_Mgr_Pg_Pu_Misc2;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cg_Wait_Cnt : 16;
        unsigned int Pg_Wait_Cnt : 16;
    } reg;
} Reg_Pwr_Mgr_Wait_3d_Cnt0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Cg_Wait_Cnt : 16;
        unsigned int Pg_Wait_Cnt : 16;
    } reg;
} Reg_Pwr_Mgr_Wait_S3vd_Cnt1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Wait_Cnt : 16;
        unsigned int Pg_Wait_Cnt : 16;
    } reg;
} Reg_Pwr_Mgr_Wait_Vpp_Cnt2;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Wait_Cnt : 16;
        unsigned int Reserved : 16;  
    } reg;
} Reg_Pwr_Mgr_Wait_Mxu0_Cnt3;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Sw_Ctl_3d_En : 1;   
        unsigned int Sw_Ctl_S3vd0_En : 1;   
        unsigned int Sw_Ctl_S3vd1_En : 1;   
        unsigned int Sw_Ctl_Vpp_En : 1;   
        unsigned int Sw_Ctl_Mxu0_En : 1;   
        unsigned int Sw_Boot_3d : 1;   
        unsigned int Sw_Boot_S3vd0 : 1;   
        unsigned int Sw_Boot_S3vd1 : 1;   
        unsigned int Sw_Boot_Vpp : 1;   
        unsigned int Sw_Boot_Mxu0 : 1;   
        unsigned int Reserved : 22;  
    } reg;
} Reg_Pwr_Mgr_Sw_Cfg_En;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Sw_Ctl_3d_Centroy_Clken : 1;   
        unsigned int Sw_Ctl_3d_Slc0_Clken : 1;   
        unsigned int Sw_Ctl_3d_Slc1_Clken : 1;   
        unsigned int Sw_Ctl_S3vd0_Clken : 1;   
        unsigned int Sw_Ctl_S3vd1_Clken : 1;   
        unsigned int Sw_Ctl_Vpp_Clken : 1;   
        unsigned int Sw_Ctl_Mxu0_Clken : 1;   
        unsigned int Sw_Ctl_3d_Centroy_Isoon : 1;   
        unsigned int Sw_Ctl_3d_Slc0_Isoon : 1;   
        unsigned int Sw_Ctl_3d_Slc1_Isoon : 1;   
        unsigned int Sw_Ctl_S3vd0_Isoon : 1;   
        unsigned int Sw_Ctl_S3vd1_Isoon : 1;   
        unsigned int Sw_Ctl_Vpp_Isoon : 1;   
        unsigned int Sw_Ctl_3d_Centroy_Rston : 1;   
        unsigned int Sw_Ctl_3d_Slc0_Rston : 1;   
        unsigned int Sw_Ctl_3d_Slc1_Rston : 1;   
        unsigned int Sw_Ctl_S3vd0_Rston : 1;   
        unsigned int Sw_Ctl_S3vd1_Rston : 1;   
        unsigned int Sw_Ctl_Vpp_Rston : 1;   
        unsigned int Sw_Ctl_3d_Centroy_Pwron : 1;   
        unsigned int Sw_Ctl_3d_Slc0_Pwron : 1;   
        unsigned int Sw_Ctl_3d_Slc1_Pwron : 1;   
        unsigned int Sw_Ctl_S3vd0_Pwron : 1;   
        unsigned int Sw_Ctl_S3vd1_Pwron : 1;   
        unsigned int Sw_Ctl_Vpp_Pwron : 1;   
        unsigned int Reserved : 7;   
    } reg;
} Reg_Pwr_Mgr_Sw_Cfg0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Csp_Pwm_L2_Clken : 1;   
        unsigned int Csp_Pwm_Pool_Clken : 1;   
        unsigned int Csp_Pwm_Sgtbe_Clken : 1;   
        unsigned int Csp_Pwm_Sptfe_Clken : 1;   
        unsigned int Csp_Pwm_Euc0_Clken : 1;   
        unsigned int Csp_Pwm_Ffu0_Clken : 1;   
        unsigned int Csp_Pwm_Tu0_Clken : 1;   
        unsigned int Csp_Pwm_Pea0_Clken : 1;   
        unsigned int Csp_Pwm_Peb0_Clken : 1;   
        unsigned int Csp_Pwm_Euc1_Clken : 1;   
        unsigned int Csp_Pwm_Ffu1_Clken : 1;   
        unsigned int Csp_Pwm_Tu1_Clken : 1;   
        unsigned int Csp_Pwm_Pea1_Clken : 1;   
        unsigned int Csp_Pwm_Peb1_Clken : 1;   
        unsigned int Csp_Pwm_S3vd0_Clken : 1;   
        unsigned int Csp_Pwm_S3vd1_Clken : 1;   
        unsigned int Csp_Pwm_Vpp_Clken : 1;   
        unsigned int Csp_Pwm_Mxu0_Clken : 1;   
        unsigned int Csp_Pwm_L2_Isoon : 1;   
        unsigned int Csp_Pwm_Pool_Isoon : 1;   
        unsigned int Csp_Pwm_Sgtbe_Isoon : 1;   
        unsigned int Csp_Pwm_Sptfe_Isoon : 1;   
        unsigned int Csp_Pwm_Euc0_Isoon : 1;   
        unsigned int Csp_Pwm_Ffu0_Isoon : 1;   
        unsigned int Csp_Pwm_Tu0_Isoon : 1;   
        unsigned int Csp_Pwm_Pea0_Isoon : 1;   
        unsigned int Csp_Pwm_Peb0_Isoon : 1;   
        unsigned int Csp_Pwm_Euc1_Isoon : 1;   
        unsigned int Csp_Pwm_Ffu1_Isoon : 1;   
        unsigned int Csp_Pwm_Tu1_Isoon : 1;   
        unsigned int Csp_Pwm_Pea1_Isoon : 1;   
        unsigned int Csp_Pwm_Peb1_Isoon : 1;   
    } reg;
} Reg_Pwr_Mgr_Status0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Csp_Pwm_S3vd0_Isoon : 1;   
        unsigned int Csp_Pwm_S3vd1_Isoon : 1;   
        unsigned int Csp_Pwm_Vpp_Isoon : 1;   
        unsigned int Csp_Pwm_L2_Rston : 1;   
        unsigned int Csp_Pwm_Pool_Rston : 1;   
        unsigned int Csp_Pwm_Sgtbe_Rston : 1;   
        unsigned int Csp_Pwm_Sptfe_Rston : 1;   
        unsigned int Csp_Pwm_Euc0_Rston : 1;   
        unsigned int Csp_Pwm_Ffu0_Rston : 1;   
        unsigned int Csp_Pwm_Tu0_Rston : 1;   
        unsigned int Csp_Pwm_Pea0_Rston : 1;   
        unsigned int Csp_Pwm_Peb0_Rston : 1;   
        unsigned int Csp_Pwm_Euc1_Rston : 1;   
        unsigned int Csp_Pwm_Ffu1_Rston : 1;   
        unsigned int Csp_Pwm_Tu1_Rston : 1;   
        unsigned int Csp_Pwm_Pea1_Rston : 1;   
        unsigned int Csp_Pwm_Peb1_Rston : 1;   
        unsigned int Csp_Pwm_S3vd0_Rston : 1;   
        unsigned int Csp_Pwm_S3vd1_Rston : 1;   
        unsigned int Csp_Pwm_Vpp_Rston : 1;   
        unsigned int Csp_Pwm_Central_Pwron : 1;   
        unsigned int Csp_Pwm_Slc0_Pwron : 1;   
        unsigned int Csp_Pwm_Slc1_Pwron : 1;   
        unsigned int Csp_Pwm_S3vd0_Pwron : 1;   
        unsigned int Csp_Pwm_S3vd1_Pwron : 1;   
        unsigned int Csp_Pwm_Vpp_Pwron : 1;   
        unsigned int Csp_Pwm_Central_Pwron_Be : 1;    
        unsigned int Csp_Pwm_Slc0_Pwron_Be : 1;   
        unsigned int Csp_Pwm_Slc1_Pwron_Be : 1;   
        unsigned int Csp_Pwm_S3vd0_Pwron_Be : 1;   
        unsigned int Csp_Pwm_S3vd1_Pwron_Be : 1;   
        unsigned int Csp_Pwm_Vpp_Pwron_Be : 1;   
    } reg;
} Reg_Pwr_Mgr_Status1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Skip_4;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_En : 1;   
        unsigned int Ts_Mode_Sel : 1;   
        unsigned int Reg_Ts_H_Th : 10;  
        unsigned int Reg_Ts_D2_Sel : 8;   
        unsigned int Tm_Selx : 6;   
        unsigned int Tm_Clkout_Edge_Sel : 1;   
        unsigned int Tm_Bg_Pdb : 1;   
        unsigned int Tm_Clksel : 3;   
        unsigned int Rtm_Step3_Once : 1;   
    } reg;
} Reg_Pwr_Ts_Cfg_En;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_Level0 : 10;  
        unsigned int Ts_Level1 : 10;  
        unsigned int Ts_Level2 : 10;  
        unsigned int Reserved : 2;   
    } reg;
} Reg_Pwr_Ts_Cfg_Misc0;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_Level3 : 10;  
        unsigned int Ts_Level4 : 10;  
        unsigned int Reserved : 12;  
    } reg;
} Reg_Pwr_Ts_Cfg_Misc1;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_C0 : 20;  
        unsigned int Reserved : 12;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc2;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_C1 : 20;  
        unsigned int Reserved : 12;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc3;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_C2 : 20;  
        unsigned int Reserved : 12;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc4;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_C3 : 20;  
        unsigned int Reserved : 12;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc5;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ts_C4 : 20;  
        unsigned int Reserved : 12;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc6;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Tm_Clkout_Cnt : 20;  
        unsigned int Tm_Gl : 7;   
        unsigned int Reserved : 5;
    } reg;
} Reg_Pwr_Ts_Cfg_Misc7;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Skip_5;
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Skip_6;


typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_C3d_Eng_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_C3d_Eng_Alu_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_C3d_Mem_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Vpp_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Vcp0_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Vcp1_Workload;

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int     uint;
	} reg;
} Reg_Csp_Skip_2;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int     uint;
    } reg;
} Reg_Csp_Skip0;

#define Reg_VCP_RUN_LIST_CTX_ADDR_Addr_BitField_MaxValue ((1u << 28) - 1)
#define Reg_VCP_RUN_LIST_CTX_ADDR_Reserved_BitField_MaxValue ((1u << 3) - 1)
#define Reg_VCP_RUN_LIST_CTX_ADDR_Kickoff_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Addr : 28;  
		unsigned int Reserved : 3;
		unsigned int Kickoff : 1;   
	} reg;
} Reg_Vcp_Run_List_Ctx_Addr;

#define Reg_VCP_RING_BUF_SIZE_Rb_Size_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Size : 32;  
	} reg;
} Reg_Vcp_Ring_Buf_Size;

#define Reg_VCP_RING_BUF_HEAD_Rb_Head_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Head : 32;  
	} reg;
} Reg_Vcp_Ring_Buf_Head;

#define Reg_VCP_RING_BUF_TAIL_Rb_Tail_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Tail : 32;  
	} reg;
} Reg_Vcp_Ring_Buf_Tail;

typedef struct _Group_Vcp_Ring_Buf
{
	Reg_Vcp_Run_List_Ctx_Addr        reg_Vcp_Run_List_Ctx_Addr;
	Reg_Vcp_Ring_Buf_Size            reg_Vcp_Ring_Buf_Size;
	Reg_Vcp_Ring_Buf_Head            reg_Vcp_Ring_Buf_Head;
	Reg_Vcp_Ring_Buf_Tail            reg_Vcp_Ring_Buf_Tail;
} Reg_Vcp_Ring_Buf_Group;

#define Reg_VPP_RUN_LIST_CTX_ADDR_Addr_BitField_MaxValue ((1u << 28) - 1)
#define Reg_VPP_RUN_LIST_CTX_ADDR_Reserved_BitField_MaxValue ((1u << 3) - 1)
#define Reg_VPP_RUN_LIST_CTX_ADDR_Kickoff_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Addr : 28;  
		unsigned int Reserved : 3;
		unsigned int Kickoff : 1;   
	} reg;
} Reg_Vpp_Run_List_Ctx_Addr;

#define Reg_VPP_RING_BUF_SIZE_Rb_Size_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Size : 32;  
	} reg;
} Reg_Vpp_Ring_Buf_Size;

#define Reg_VPP_RING_BUF_HEAD_Rb_Head_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Head : 32;  
	} reg;
} Reg_Vpp_Ring_Buf_Head;

#define Reg_VPP_RING_BUF_TAIL_Rb_Tail_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Rb_Tail : 32;  
	} reg;
} Reg_Vpp_Ring_Buf_Tail;

typedef struct _Group_Vpp_Ring_Buf
{
	Reg_Vpp_Run_List_Ctx_Addr        reg_Vpp_Run_List_Ctx_Addr;
	Reg_Vpp_Ring_Buf_Size            reg_Vpp_Ring_Buf_Size;
	Reg_Vpp_Ring_Buf_Head            reg_Vpp_Ring_Buf_Head;
	Reg_Vpp_Ring_Buf_Tail            reg_Vpp_Ring_Buf_Tail;
} Reg_Vpp_Ring_Buf_Group;

#define Reg_VCP_VPP_BLOCK_BUSY_BITS_Vcp0_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_VCP_VPP_BLOCK_BUSY_BITS_Vcp1_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_VCP_VPP_BLOCK_BUSY_BITS_Vpp_Busy_BitField_MaxValue ((1u << 1) - 1)
#define Reg_VCP_VPP_BLOCK_BUSY_BITS_Reserved_BitField_MaxValue ((1u << 29) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Vcp0_Busy : 1;
		unsigned int Vcp1_Busy : 1;
		unsigned int Vpp_Busy : 1;
		unsigned int Reserved : 29;
	} reg;
} Reg_Vcp_Vpp_Block_Busy_Bits;

#define Reg_CMODEL_DMA_PREEMPTION_BEGIN_Begin_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Begin : 1;
        unsigned int Reserved : 31;
    } reg;
} Reg_Cmodel_Dma_Preemption_Begin;

#define Reg_CMODEL_DMA_PREEMPTION_CNT_Dma_Preempt_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_CMODEL_DMA_PREEMPTION_CNT_Indicator_Off_Cnt_BitField_MaxValue ((1u << 31) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Dma_Preempt_En : 1;  
        unsigned int Indicator_Off_Cnt : 31;  
    } reg;
} Reg_Cmodel_Dma_Preemption_Cnt;

#define Reg_CMODEL_DMA_PREEMPTION_TAIL_Tailpoint_Skipto_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Tailpoint_Skipto : 32;  
    } reg;
} Reg_Cmodel_Dma_Preemption_Tail;

#define Reg_CMODEL_HL_SWITCH_Cmd_Type_BitField_MaxValue ((1u << 3) - 1)
#define Reg_CMODEL_HL_SWITCH_Cmd_Cnt_BitField_MaxValue ((1u << 5) - 1)
#define Reg_CMODEL_HL_SWITCH_Draw_Cnt_BitField_MaxValue ((1u << 5) - 1)
#define Reg_CMODEL_HL_SWITCH_Reserved_BitField_MaxValue ((1u << 19) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Cmd_Type : 3;
		unsigned int Cmd_Cnt : 5;
		unsigned int Draw_Cnt : 5;
		unsigned int Reserved : 19;
	} reg;
} Reg_Cmodel_Hl_Switch;

#define Reg_EU_DBG_CFG_Exec_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_CFG_Th_Mode_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_CFG_Int_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_CFG_Res_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_CFG_Dbg_Th_Id_BitField_MaxValue ((1u << 5) - 1)
#define Reg_EU_DBG_CFG_Reserved_BitField_MaxValue ((1u << 23) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Exec_En : 1;   
		unsigned int Th_Mode : 1;   
		unsigned int Int_En : 1;   
		unsigned int Res_En : 1;   
		unsigned int Dbg_Th_Id : 5;   
		unsigned int Reserved : 23;  
	} reg;
} Reg_Eu_Dbg_Cfg;

#define Reg_EU_DBG_BP_STAT_Bp_Hit_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_BP_STAT_Bp_Id_BitField_MaxValue ((1u << 3) - 1)
#define Reg_EU_DBG_BP_STAT_Hit_Th_Id_BitField_MaxValue ((1u << 5) - 1)
#define Reg_EU_DBG_BP_STAT_Reserved_BitField_MaxValue ((1u << 23) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Bp_Hit : 1;   
		unsigned int Bp_Id : 3;   
		unsigned int Hit_Th_Id : 5;   
		unsigned int Reserved : 23;  
	} reg;
} Reg_Eu_Dbg_Bp_Stat;

#define Reg_EU_DBG_BP_PC_Bp_Valid_BitField_MaxValue ((1u << 1) - 1)
#define Reg_EU_DBG_BP_PC_Shader_BitField_MaxValue ((1u << 3) - 1)
#define Reg_EU_DBG_BP_PC_Offset_BitField_MaxValue ((1u << 16) - 1)
#define Reg_EU_DBG_BP_PC_Reserved_BitField_MaxValue ((1u << 12) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Bp_Valid : 1;   
		unsigned int Shader : 3;   
		unsigned int Offset : 16;  
		unsigned int Reserved : 12;  
	} reg;
} Reg_Eu_Dbg_Bp_Pc;

#define Reg_EU_DBG_INT_INSTR_Offset_BitField_MaxValue ((1u << 16) - 1)
#define Reg_EU_DBG_INT_INSTR_Reserved_BitField_MaxValue ((1u << 16) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Offset : 16;  
		unsigned int Reserved : 16;  
	} reg;
} Reg_Eu_Dbg_Int_Instr;

#define Reg_EU_DBG_RES_INSTR_Offset_BitField_MaxValue ((1u << 16) - 1)
#define Reg_EU_DBG_RES_INSTR_Reserved_BitField_MaxValue ((1u << 16) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Offset : 16;  
		unsigned int Reserved : 16;  
	} reg;
} Reg_Eu_Dbg_Res_Instr;

#define Reg_EU_DBG_TIME_STAMP_Value_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Value : 32;  
	} reg;
} Reg_Eu_Dbg_Time_Stamp;

#define Reg_EU_DBG_REVERSED_Reserved_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
	unsigned int uint;
	struct
	{
		unsigned int Reserved : 32;  
	} reg;
} Reg_Eu_Dbg_Reversed;

typedef struct _Group_Eu_Dbg_Reg
{
	Reg_Eu_Dbg_Cfg                   reg_Eu_Dbg_Cfg;
	Reg_Eu_Dbg_Bp_Stat               reg_Eu_Dbg_Bp_Stat;
	Reg_Eu_Dbg_Bp_Pc                 reg_Eu_Dbg_Bp_Pc[8];
	Reg_Eu_Dbg_Int_Instr             reg_Eu_Dbg_Int_Instr;
	Reg_Eu_Dbg_Res_Instr             reg_Eu_Dbg_Res_Instr;
	Reg_Eu_Dbg_Time_Stamp            reg_Eu_Dbg_Time_Stamp[2];
	Reg_Eu_Dbg_Reversed              reg_Eu_Dbg_Reversed[2];
} Reg_Eu_Dbg_Reg_Group;

typedef struct _Csp_Global_regs_CHX004
{
	Reg_Block_Busy_Bits_Top          reg_Block_Busy_Bits_Top;
	Reg_Block_Busy_Bits_Gpc0_0       reg_Block_Busy_Bits_Gpc0_0;
	Reg_Block_Busy_Bits_Gpc0_1       reg_Block_Busy_Bits_Gpc0_1;
	Reg_Block_Busy_Bits_Gpc1_0       reg_Block_Busy_Bits_Gpc1_0;
	Reg_Block_Busy_Bits_Gpc1_1       reg_Block_Busy_Bits_Gpc1_1;
	Reg_Block_Busy_Bits_Gpc2_0       reg_Block_Busy_Bits_Gpc2_0;
	Reg_Block_Busy_Bits_Gpc2_1       reg_Block_Busy_Bits_Gpc2_1;
	Reg_Ring_Buf_Group               reg_Ring_Buf[7];
	Reg_Preempt_Cmd_Process          reg_Preempt_Cmd_Process;
	Reg_Cpu_Set                      reg_Cpu_Set;
	Reg_Fence_Mask                   reg_Fence_Mask;
	Reg_Trans_Threshold_Cnt          reg_Trans_Threshold_Cnt;
	Reg_Pfb_Partition_3d_Cfg         reg_Pfb_Partition_3d_Cfg;
	Reg_Pfb_Partition_Cs_Cfg         reg_Pfb_Partition_Cs_Cfg;
	Reg_Csp_Ref_Total_Gpu_Timestamp  reg_Csp_Ref_Total_Gpu_Timestamp[2];
	Reg_Csp_Ms_Total_Busy_Time       reg_Csp_Ms_Total_Busy_Time[2];
	Reg_Csp_Ms_Query_Occlusion       reg_Csp_Ms_Query_Occlusion[2];
	Reg_Csp_Ms_Total_Gpu_Timestamp   reg_Csp_Ms_Total_Gpu_Timestamp[2];
	Reg_Csp_Skip_1                   reg_Csp_Skip_1[2];
	Reg_Ia_Ogl_Cut_Flag_32           reg_Ia_Ogl_Cut_Flag_32;
	Reg_Ia_Vb0_Offset                reg_Ia_Vb0_Offset;
	Reg_Ia_Vb0_Stride                reg_Ia_Vb0_Stride;
	Reg_Ia_Bufferfilledsize          reg_Ia_Bufferfilledsize;
	Reg_Ia_Batch_Cfg                 reg_Ia_Batch_Cfg;
	Reg_Predicate_Status             reg_Predicate_Status;
	Reg_Csp_Misc_Control             reg_Csp_Misc_Control;
	Reg_Index_Buf_Fmt_Enum           reg_Index_Buf_Fmt_Enum;
	Reg_Ia_Input_Vertices_Cnt        reg_Ia_Input_Vertices_Cnt[2];
	Reg_Ia_Output_Vertices_Cnt       reg_Ia_Output_Vertices_Cnt[2];
	Reg_Ia_Primitives_Cnt            reg_Ia_Primitives_Cnt[2];
	Reg_Csp_Skip_2                   reg_Csp_Skip_2[6];
	Reg_Csp_Fence_Counter_Group      reg_Csp_Fence_Counter[16];
	Reg_Ila_Counters                 reg_Ila_Counters[40];
	Reg_Gpc_Signature_Group          reg_Gpc_Signature[3];
	Reg_Sto_Signature_Group          reg_Sto_Signature[4];
	Reg_Csp_Slice_Status             reg_Csp_Slice_Status;
	Reg_Cur_L1_Dma_Cmd               reg_Cur_L1_Dma_Cmd;
	Reg_Cur_L2_Dma_Cmd               reg_Cur_L2_Dma_Cmd;
	Reg_Cur_3d_Rbuf_Cmd              reg_Cur_3d_Rbuf_Cmd;
	Reg_Cur_3d_Hrbuf_Cmd             reg_Cur_3d_Hrbuf_Cmd;
	Reg_Cur_Csh_Rbuf_Cmd             reg_Cur_Csh_Rbuf_Cmd;
	Reg_Cur_Cs0_Rbuf_Cmd             reg_Cur_Cs0_Rbuf_Cmd;
	Reg_Cur_Cs1_Rbuf_Cmd             reg_Cur_Cs1_Rbuf_Cmd;
	Reg_Cur_Cs2_Rbuf_Cmd             reg_Cur_Cs2_Rbuf_Cmd;
	Reg_Cur_Cs3_Rbuf_Cmd             reg_Cur_Cs3_Rbuf_Cmd;
    Reg_U_Fence_Num_Ctrl             reg_U_Fence_Num_Ctrl;
    Reg_Csp_Skip_3                   reg_Csp_Skip_3[8];
    Reg_Reg_Dvfs_Cfg_En              reg_Reg_Dvfs_Cfg_En;
    Reg_Reg_Dvfs_Cfg_Misc0           reg_Reg_Dvfs_Cfg_Misc0;
    Reg_Reg_3d_Dvfs_Checksize        reg_Reg_3d_Dvfs_Checksize;
    Reg_Reg_3d_Dvfs_H_Th             reg_Reg_3d_Dvfs_H_Th;
    Reg_Reg_3d_Dvfs_L_Th             reg_Reg_3d_Dvfs_L_Th;
    Reg_Reg_3d_Dvfs_H_Th_Mem         reg_Reg_3d_Dvfs_H_Th_Mem;
    Reg_Reg_3d_Alu_Workload          reg_Reg_3d_Alu_Workload;
    Reg_Reg_3d_Busy_Workload         reg_Reg_3d_Busy_Workload;
    Reg_Reg_Vcp0_Dvfs_Checksize      reg_Reg_Vcp0_Dvfs_Checksize;
    Reg_Reg_Vcp0_Dvfs_H_Th           reg_Reg_Vcp0_Dvfs_H_Th;
    Reg_Reg_Vcp0_Dvfs_L_Th           reg_Reg_Vcp0_Dvfs_L_Th;
    Reg_Reg_Vcp0_Dvfs_H_Th_Mem       reg_Reg_Vcp0_Dvfs_H_Th_Mem;
    Reg_Reg_Vcp0_Busy_Cycle          reg_Reg_Vcp0_Busy_Cycle;
    Reg_Reg_Vcp1_Dvfs_Checksize      reg_Reg_Vcp1_Dvfs_Checksize;
    Reg_Reg_Vcp1_Dvfs_H_Th           reg_Reg_Vcp1_Dvfs_H_Th;
    Reg_Reg_Vcp1_Dvfs_L_Th           reg_Reg_Vcp1_Dvfs_L_Th;
    Reg_Reg_Vcp1_Dvfs_H_Th_Mem       reg_Reg_Vcp1_Dvfs_H_Th_Mem;
    Reg_Reg_Vcp1_Busy_Cycle          reg_Reg_Vcp1_Busy_Cycle;
    Reg_Reg_Vpp_Dvfs_Checksize       reg_Reg_Vpp_Dvfs_Checksize;
    Reg_Reg_Vpp_Dvfs_H_Th            reg_Reg_Vpp_Dvfs_H_Th;
    Reg_Reg_Vpp_Dvfs_L_Th            reg_Reg_Vpp_Dvfs_L_Th;
    Reg_Reg_Vpp_Dvfs_H_Th_Mem        reg_Reg_Vpp_Dvfs_H_Th_Mem;
    Reg_Reg_Vpp_Busy_Cycle           reg_Reg_Vpp_Busy_Cycle;
    Reg_Reg_Dvfs_Pcu_Cfg_En          reg_Reg_Dvfs_Pcu_Cfg_En;
    Reg_Reg_3d_Mem_Busy_Cycle        reg_Reg_3d_Mem_Busy_Cycle;
    Reg_Reg_Vcp0_Mem_Busy_Cycle      reg_Reg_Vcp0_Mem_Busy_Cycle;
    Reg_Reg_Vcp1_Mem_Busy_Cycle      reg_Reg_Vcp1_Mem_Busy_Cycle;
    Reg_Reg_Vpp_Mem_Busy_Cycle       reg_Reg_Vpp_Mem_Busy_Cycle;
    Reg_Pwr_Mgr_Cfg_En               reg_Pwr_Mgr_Cfg_En;
    Reg_Pwr_Mgr_Pg_Pd_Misc0          reg_Pwr_Mgr_Pg_Pd_Misc0;
    Reg_Pwr_Mgr_Pg_Pd_Misc1          reg_Pwr_Mgr_Pg_Pd_Misc1;
    Reg_Pwr_Mgr_Pg_Pd_Misc2          reg_Pwr_Mgr_Pg_Pd_Misc2;
    Reg_Pwr_Mgr_Pg_Pu_Misc0          reg_Pwr_Mgr_Pg_Pu_Misc0;
    Reg_Pwr_Mgr_Pg_Pu_Misc1          reg_Pwr_Mgr_Pg_Pu_Misc1;
    Reg_Pwr_Mgr_Pg_Pu_Misc2          reg_Pwr_Mgr_Pg_Pu_Misc2;
    Reg_Pwr_Mgr_Wait_3d_Cnt0         reg_Pwr_Mgr_Wait_3d_Cnt0;
    Reg_Pwr_Mgr_Wait_S3vd_Cnt1       reg_Pwr_Mgr_Wait_S3vd_Cnt1;
    Reg_Pwr_Mgr_Wait_Vpp_Cnt2        reg_Pwr_Mgr_Wait_Vpp_Cnt2;
    Reg_Pwr_Mgr_Wait_Mxu0_Cnt3       reg_Pwr_Mgr_Wait_Mxu0_Cnt3;
    Reg_Pwr_Mgr_Sw_Cfg_En            reg_Pwr_Mgr_Sw_Cfg_En;
    Reg_Pwr_Mgr_Sw_Cfg0              reg_Pwr_Mgr_Sw_Cfg0;
    Reg_Pwr_Mgr_Status0              reg_Pwr_Mgr_Status0;
    Reg_Pwr_Mgr_Status1              reg_Pwr_Mgr_Status1;
    Reg_Csp_Skip_4                   reg_Csp_Skip_4[21];
    Reg_Pwr_Ts_Cfg_En                reg_Pwr_Ts_Cfg_En;
    Reg_Pwr_Ts_Cfg_Misc0             reg_Pwr_Ts_Cfg_Misc0;
    Reg_Pwr_Ts_Cfg_Misc1             reg_Pwr_Ts_Cfg_Misc1;
    Reg_Pwr_Ts_Cfg_Misc2             reg_Pwr_Ts_Cfg_Misc2;
    Reg_Pwr_Ts_Cfg_Misc3             reg_Pwr_Ts_Cfg_Misc3;
    Reg_Pwr_Ts_Cfg_Misc4             reg_Pwr_Ts_Cfg_Misc4;
    Reg_Pwr_Ts_Cfg_Misc5             reg_Pwr_Ts_Cfg_Misc5;
    Reg_Pwr_Ts_Cfg_Misc6             reg_Pwr_Ts_Cfg_Misc6;
    Reg_Pwr_Ts_Cfg_Misc7             reg_Pwr_Ts_Cfg_Misc7;
    Reg_Csp_Skip_5                   reg_Csp_Skip_5[55];
    Reg_Vcp_Ring_Buf_Group           reg_Vcp_Ring_Buf[2];
    Reg_Vpp_Ring_Buf_Group           reg_Vpp_Ring_Buf;
    Reg_Vcp_Vpp_Block_Busy_Bits      reg_Vcp_Vpp_Block_Busy_Bits;
    Reg_Csp_Skip_6                   reg_Csp_Skip_6[111];
    Reg_Cmodel_Dma_Preemption_Begin  reg_Cmodel_Dma_Preemption_Begin;
    Reg_Cmodel_Dma_Preemption_Cnt    reg_Cmodel_Dma_Preemption_Cnt;
    Reg_Cmodel_Dma_Preemption_Tail   reg_Cmodel_Dma_Preemption_Tail;
    Reg_Cmodel_Hl_Switch             reg_Cmodel_Hl_Switch;
    Reg_Eu_Dbg_Reg_Group             reg_Eu_Dbg_Reg[24];
} Csp_Global_regs_CHX004;

typedef struct _Csp_Global_regs_Elt3k
{
    Reg_Block_Busy_Bits_Top          reg_Block_Busy_Bits_Top;
    Reg_Block_Busy_Bits_Gpc0_0       reg_Block_Busy_Bits_Gpc0_0;
    Reg_Block_Busy_Bits_Gpc0_1       reg_Block_Busy_Bits_Gpc0_1;
    Reg_Block_Busy_Bits_Gpc1_0       reg_Block_Busy_Bits_Gpc1_0;
    Reg_Block_Busy_Bits_Gpc1_1       reg_Block_Busy_Bits_Gpc1_1;
    Reg_Block_Busy_Bits_Gpc2_0       reg_Block_Busy_Bits_Gpc2_0;
    Reg_Block_Busy_Bits_Gpc2_1       reg_Block_Busy_Bits_Gpc2_1;
    Reg_Ring_Buf_Group               reg_Ring_Buf[7];
    Reg_Preempt_Cmd_Process          reg_Preempt_Cmd_Process;
    Reg_Cpu_Set                      reg_Cpu_Set;
    Reg_Fence_Mask                   reg_Fence_Mask;
    Reg_Reserved_Dw_0                reg_Reserved_Dw_0;
    Reg_Pfb_Partition_3d_Cfg         reg_Pfb_Partition_3d_Cfg;
    Reg_Pfb_Partition_Cs_Cfg         reg_Pfb_Partition_Cs_Cfg;
    Reg_Csp_Ms_Total_Gpu_Timestamp   reg_Csp_Ms_Total_Gpu_Timestamp[2];
    Reg_Csp_Ms_Total_Busy_Time       reg_Csp_Ms_Total_Busy_Time[2];
    Reg_Csp_Ms_Query_Occlusion       reg_Csp_Ms_Query_Occlusion[2];
    Reg_Ia_Vertices_Cnt              reg_Ia_Vertices_Cnt[2];
    Reg_Ia_Primitives_Cnt            reg_Ia_Primitives_Cnt[2];
    Reg_Ia_Ogl_Cut_Flag_32           reg_Ia_Ogl_Cut_Flag_32;
    Reg_Ia_Vb0_Offset                reg_Ia_Vb0_Offset;
    Reg_Ia_Vb0_Stride                reg_Ia_Vb0_Stride;
    Reg_Ia_Bufferfilledsize          reg_Ia_Bufferfilledsize;
    Reg_Ia_Batch_Cfg                 reg_Ia_Batch_Cfg;
    Reg_Predicate_Status             reg_Predicate_Status;
    Reg_Csp_Misc_Control             reg_Csp_Misc_Control;
    Reg_Tbr_Render_Mode_Ctrl         reg_Tbr_Render_Mode_Ctrl;
    Reg_Tbr_Frametimestamp_Lth       reg_Tbr_Frametimestamp_Lth;
    Reg_Tbr_Frametimestamp_Hth       reg_Tbr_Frametimestamp_Hth;
    Reg_Tbr_Traffic_Th               reg_Tbr_Traffic_Th;
    Reg_Tbr_Event_Count_Ref          reg_Tbr_Event_Count_Ref;
    Reg_Descriptor_Base_Addr_Group   reg_Descriptor_Base_Addr[8];
    Reg_Csp_Fence_Counter_Group      reg_Csp_Fence_Counter[16];
    Reg_Ila_Counters                 reg_Ila_Counters[40];
    Reg_Gpc_Signature_Group          reg_Gpc_Signature[3];
    Reg_Sto_Signature_Group          reg_Sto_Signature[4];
    Reg_Csp_Slice_Status             reg_Csp_Slice_Status;
    Reg_Cur_L1_Dma_Cmd               reg_Cur_L1_Dma_Cmd;
    Reg_Cur_L2_Dma_Cmd               reg_Cur_L2_Dma_Cmd;
    Reg_Cur_3d_Rbuf_Cmd              reg_Cur_3d_Rbuf_Cmd;
    Reg_Cur_3d_Hrbuf_Cmd             reg_Cur_3d_Hrbuf_Cmd;
    Reg_Cur_Csh_Rbuf_Cmd             reg_Cur_Csh_Rbuf_Cmd;
    Reg_Cur_Cs0_Rbuf_Cmd             reg_Cur_Cs0_Rbuf_Cmd;
    Reg_Cur_Cs1_Rbuf_Cmd             reg_Cur_Cs1_Rbuf_Cmd;
    Reg_Cur_Cs2_Rbuf_Cmd             reg_Cur_Cs2_Rbuf_Cmd;
    Reg_Cur_Cs3_Rbuf_Cmd             reg_Cur_Cs3_Rbuf_Cmd;
    Reg_C3d_Eng_Workload             reg_C3d_Eng_Workload;
    Reg_C3d_Eng_Alu_Workload         reg_C3d_Eng_Alu_Workload;
    Reg_C3d_Mem_Workload             reg_C3d_Mem_Workload;
    Reg_Vpp_Workload                 reg_Vpp_Workload;
    Reg_Vcp0_Workload                reg_Vcp0_Workload;
    Reg_Vcp1_Workload                reg_Vcp1_Workload;
    Reg_Csp_Skip0                    reg_Csp_Skip0[131];
    Reg_Vcp_Ring_Buf_Group           reg_Vcp_Ring_Buf[2];
    Reg_Vpp_Ring_Buf_Group           reg_Vpp_Ring_Buf;
    Reg_Vcp_Vpp_Block_Busy_Bits      reg_Vcp_Vpp_Block_Busy_Bits;
    Reg_Csp_Skip_1                   reg_Csp_Skip1[114];
    Reg_Cmodel_Hl_Switch             reg_Cmodel_Hl_Switch;
    Reg_Eu_Dbg_Reg_Group             reg_Eu_Dbg_Reg[24];
} Csp_Global_regs_Elt3k;

#endif
