#ifndef _EU_PS_REGISTER_H
#define _EU_PS_REGISTER_H


#ifndef        EU_PS_BLOCKBASE_INF
    #define    EU_PS_BLOCKBASE_INF
    #define    BLOCK_EU_PS_VERSION 1
    #define    BLOCK_EU_PS_TIMESTAMP "2018/11/26 19:05:36"
    #define    EU_PS_BLOCK                                                0x9 
    #define    EU_PS_REG_START                                            0x0 
    #define    EU_PS_REG_END                                              0x900 
    #define    EU_PS_REG_LIMIT                                            0x900 
#endif

#define        Reg_Ps_Cfg_Offset                                          0x0
#define        Reg_Ps_Ctrl_Offset                                         0x1
#define        Reg_Ps_Out_Cfg_Offset                                      0x2
#define        Reg_Ps_Doutbuf_Cfg_Offset                                  0x3
#define        Reg_Ps_Pm_Cfg_Offset                                       0x4
#define        Reg_Ps_Pm_Id_Offset                                        0x5
#define        Reg_Ps_Pm_Range_Offset                                     0x6
#define        Reg_Ps_Out_Mapping_Offset                                  0x7
#define        Reg_Ps_Out_Rtfmt_Offset                                    0x8
#define        Reg_Ps_Out_Fmt_Offset                                      0x8
#define        Reg_Ps_U_Enable_Offset                                     0x9
#define        Reg_Ps_U_Fmt_Offset                                        0xB
#define        Reg_Ps_U_Layout_Offset                                     0x13
#define        Reg_Ps_U_Cfg_Offset                                        0x15
#define        Reg_Ps_Instr0_Offset                                       0x16
#define        Reg_Ps_Instr1_Offset                                       0x17
#define        Reg_Ps_Instr_Range_Offset                                  0x18
#define        Reg_Ps_Cb_Cfg_Offset                                       0x19
#define        Reg_Ps_Rev_8aligned_Offset                                 0x1A
#define        Reg_Ps_Rev_Cb_Offset                                       0x20
#define        Reg_Ps_Cb_Data_Offset                                      0x100

typedef enum
{
    PS_CFG_PS_ON_OFF                         = 0,   
    PS_CFG_PS_ON_ON                          = 1,   
} PS_CFG_PS_ON;
typedef enum
{
    PS_CTRL_AND_V_MASK_DISABLED              = 0,   
    PS_CTRL_AND_V_MASK_ENABLED               = 1,   
} PS_CTRL_AND_V_MASK;
typedef enum
{
    PS_CTRL_RD_MODE_NEAR                     = 0,   
    PS_CTRL_RD_MODE_ZERO                     = 1,   
    PS_CTRL_RD_MODE_POS                      = 2,   
    PS_CTRL_RD_MODE_NEG                      = 3,   
} PS_CTRL_RD_MODE;
typedef enum
{
    PS_CTRL_FP_MODE_STD_IEEE                 = 0,   
    PS_CTRL_FP_MODE_NSTD_IEEE                = 1,   
    PS_CTRL_FP_MODE_MS_ALT                   = 2,   
    PS_CTRL_FP_MODE_RESERVED                 = 3,   
} PS_CTRL_FP_MODE;
typedef enum
{
    PS_CTRL_DENORM_EN_DISABLED               = 0,   
    PS_CTRL_DENORM_EN_ENABLED                = 1,   
} PS_CTRL_DENORM_EN;
typedef enum
{
    PS_CTRL_THREAD_MODE_SIMD32               = 0,   
    PS_CTRL_THREAD_MODE_SIMD64               = 1,   
} PS_CTRL_THREAD_MODE;
typedef enum
{
    PS_CTRL_CUST_BLEND_EN_DISABLED           = 0,   
    PS_CTRL_CUST_BLEND_EN_ENABLED            = 1,   
} PS_CTRL_CUST_BLEND_EN;
typedef enum
{
    PS_CTRL_ROV_EN_DISABLED                  = 0,   
    PS_CTRL_ROV_EN_ENABLED                   = 1,   
} PS_CTRL_ROV_EN;
typedef enum
{
    PS_OUT_CFG_CLR_OUT_EN_OFF                = 0,   
    PS_OUT_CFG_CLR_OUT_EN_ON                 = 1,   
} PS_OUT_CFG_CLR_OUT_EN;
typedef enum
{
    PS_OUT_CFG_Z_OUT_EN_OFF                  = 0,   
    PS_OUT_CFG_Z_OUT_EN_ON                   = 1,   
} PS_OUT_CFG_Z_OUT_EN;
typedef enum
{
    PS_OUT_CFG_ALPHA_OUT_EN_OFF              = 0,   
    PS_OUT_CFG_ALPHA_OUT_EN_ON               = 1,   
} PS_OUT_CFG_ALPHA_OUT_EN;
typedef enum
{
    PS_OUT_CFG_STENCIL_OUT_EN_OFF            = 0,   
    PS_OUT_CFG_STENCIL_OUT_EN_ON             = 1,   
} PS_OUT_CFG_STENCIL_OUT_EN;
typedef enum
{
    PS_OUT_CFG_MASK_OUT_EN_OFF               = 0,   
    PS_OUT_CFG_MASK_OUT_EN_ON                = 1,   
} PS_OUT_CFG_MASK_OUT_EN;
typedef enum
{
    PS_OUT_CFG_DUAL_SRC_EN_OFF               = 0,   
    PS_OUT_CFG_DUAL_SRC_EN_ON                = 1,   
} PS_OUT_CFG_DUAL_SRC_EN;
typedef enum
{
    PS_OUT_CFG_Z_DATA_FMT_FP32               = 0,   
    PS_OUT_CFG_Z_DATA_FMT_UNORM24            = 6,   
    PS_OUT_CFG_Z_DATA_FMT_UNORM16            = 7,   
} PS_OUT_CFG_Z_DATA_FMT;
typedef enum
{
    PS_OUT_CFG_DUAL_SRC_FMT_FP16             = 1,   
    PS_OUT_CFG_DUAL_SRC_FMT_UNORM10          = 8,   
    PS_OUT_CFG_DUAL_SRC_FMT_UNORM8           = 9,   
    PS_OUT_CFG_DUAL_SRC_FMT_SNORM8           = 12,  
} PS_OUT_CFG_DUAL_SRC_FMT;
typedef enum
{
    PS_OUT_CFG_MASK_OUT_MODE_BIT1            = 0,   
    PS_OUT_CFG_MASK_OUT_MODE_BIT2            = 1,   
    PS_OUT_CFG_MASK_OUT_MODE_BIT4            = 2,   
    PS_OUT_CFG_MASK_OUT_MODE_BIT8            = 3,   
    PS_OUT_CFG_MASK_OUT_MODE_BIT16           = 4,   
} PS_OUT_CFG_MASK_OUT_MODE;
typedef enum
{
    PS_DOUTBUF_CFG_ZL3_SIZE_0LINES           = 0,   
    PS_DOUTBUF_CFG_ZL3_SIZE_16LINES          = 4,   
    PS_DOUTBUF_CFG_ZL3_SIZE_32LINES          = 5, 
    PS_DOUTBUF_CFG_ZL3_SIZE_64LINES          = 6, 
    PS_DOUTBUF_CFG_ZL3_SIZE_128LINES         = 7, 
} PS_DOUTBUF_CFG_ZL3_SIZE;
typedef enum
{
    PS_DOUTBUF_CFG_CLR_SIZE_0LINES           = 0,   
    PS_DOUTBUF_CFG_CLR_SIZE_32LINES          = 5,   
    PS_DOUTBUF_CFG_CLR_SIZE_64LINES          = 6, 
    PS_DOUTBUF_CFG_CLR_SIZE_128LINES         = 7, 
} PS_DOUTBUF_CFG_CLR_SIZE;
typedef enum
{
    PS_PM_CFG_PM_EN_DISABLED                 = 0,   
    PS_PM_CFG_PM_EN_ENABLED                  = 1,   
} PS_PM_CFG_PM_EN;
typedef enum
{
    PS_PM_CFG_TH_PM_SIZE_8KDW                = 0,   
    PS_PM_CFG_TH_PM_SIZE_16KDW               = 1,   
    PS_PM_CFG_TH_PM_SIZE_32KDW               = 2,   
    PS_PM_CFG_TH_PM_SIZE_64KDW               = 3,   
    PS_PM_CFG_TH_PM_SIZE_128KDW              = 4,   
    PS_PM_CFG_TH_PM_SIZE_256KDW              = 5,   
    PS_PM_CFG_TH_PM_SIZE_512KDW              = 6,   
    PS_PM_CFG_TH_PM_SIZE_1024KDW             = 7,   
    PS_PM_CFG_TH_PM_SIZE_1040KDW             = 8,   
} PS_PM_CFG_TH_PM_SIZE;
typedef enum
{
    PS_OUT_MAPPING_O0_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O0_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O0_EN;
typedef enum
{
    PS_OUT_MAPPING_O1_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O1_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O1_EN;
typedef enum
{
    PS_OUT_MAPPING_O2_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O2_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O2_EN;
typedef enum
{
    PS_OUT_MAPPING_O3_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O3_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O3_EN;
typedef enum
{
    PS_OUT_MAPPING_O4_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O4_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O4_EN;
typedef enum
{
    PS_OUT_MAPPING_O5_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O5_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O5_EN;
typedef enum
{
    PS_OUT_MAPPING_O6_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O6_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O6_EN;
typedef enum
{
    PS_OUT_MAPPING_O7_EN_DISABLED            = 0,   
    PS_OUT_MAPPING_O7_EN_ENABLED             = 1,   
} PS_OUT_MAPPING_O7_EN;
typedef enum
{
    PS_OUT_FMT_O0_DATA_FMT_FP32 = 0,   
    PS_OUT_FMT_O0_DATA_FMT_FP16 = 1,   
    PS_OUT_FMT_O0_DATA_FMT_SINT32 = 2,   
    PS_OUT_FMT_O0_DATA_FMT_SINT16 = 3,   
    PS_OUT_FMT_O0_DATA_FMT_UINT32 = 4,   
    PS_OUT_FMT_O0_DATA_FMT_UINT16 = 5,   
    PS_OUT_FMT_O0_DATA_FMT_UNORM24 = 6,   
    PS_OUT_FMT_O0_DATA_FMT_UNORM16 = 7,   
    PS_OUT_FMT_O0_DATA_FMT_UNORM10 = 8,   
    PS_OUT_FMT_O0_DATA_FMT_UNORM8 = 9,   
    PS_OUT_FMT_O0_DATA_FMT_SINT8 = 10,  
    PS_OUT_FMT_O0_DATA_FMT_UINT8 = 11,  
    PS_OUT_FMT_O0_DATA_FMT_SNORM8 = 12,  
    PS_OUT_FMT_O0_DATA_FMT_SNORM16 = 13,  
    PS_OUT_FMT_O0_DATA_FMT_UINT64 = 14,  
    PS_OUT_FMT_O0_DATA_FMT_RESERVED = 15,  
} PS_OUT_FMT_O0_DATA_FMT;
typedef enum
{
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32           = 0, 
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16           = 1, 
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT32         = 2, 
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT16         = 3, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32         = 4, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT16         = 5, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM24        = 6, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16        = 7, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10        = 8, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8         = 9, 
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT8          = 10, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT8          = 11, 
    PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8         = 12, 
    PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16        = 13, 
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT64         = 14, 
    PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED       = 15, 
} PS_OUT_RTFMT_RT0_DATA_FMT;

typedef enum
{
    PS_U_ENABLE_U0_EN_DISABLE                = 0,   
    PS_U_ENABLE_U0_EN_ENABLE                 = 1,   
} PS_U_ENABLE_U0_EN;
typedef enum
{
    PS_U_FMT_U0_DATA_FMT_FP32                = 0,   
    PS_U_FMT_U0_DATA_FMT_FP16                = 1,   
    PS_U_FMT_U0_DATA_FMT_SINT32              = 2,   
    PS_U_FMT_U0_DATA_FMT_SINT16              = 3,   
    PS_U_FMT_U0_DATA_FMT_UINT32              = 4,   
    PS_U_FMT_U0_DATA_FMT_UINT16              = 5,   
    PS_U_FMT_U0_DATA_FMT_UNORM24             = 6,   
    PS_U_FMT_U0_DATA_FMT_UNORM16             = 7,   
    PS_U_FMT_U0_DATA_FMT_UNORM10             = 8,   
    PS_U_FMT_U0_DATA_FMT_UNORM8              = 9,   
    PS_U_FMT_U0_DATA_FMT_SINT8               = 10,  
    PS_U_FMT_U0_DATA_FMT_UINT8               = 11,  
    PS_U_FMT_U0_DATA_FMT_SNORM8              = 12,  
    PS_U_FMT_U0_DATA_FMT_SNORM16             = 13,  
    PS_U_FMT_U0_DATA_FMT_UINT64              = 14,  
    PS_U_FMT_U0_DATA_FMT_RESERVED            = 15,  
} PS_U_FMT_U0_DATA_FMT;
typedef enum
{
    PS_U_LAYOUT_U0_LAYOUT_VERTICAL           = 0,   
    PS_U_LAYOUT_U0_LAYOUT_HORIZONTAL         = 1,   
} PS_U_LAYOUT_U0_LAYOUT;

#define Reg_PS_CFG_Ps_On_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CFG_Max_Threads_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PS_CFG_In_Size_BitField_MaxValue ((1u << 6) - 1)
#define Reg_PS_CFG_Reserved1_BitField_MaxValue ((1u << 17) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ps_On                     : 1;   
        unsigned int Max_Threads               : 8;   
        unsigned int In_Size                   : 6;   
        unsigned int Reserved1                 : 17;  
    } reg;
} Reg_Ps_Cfg;
 
#define Reg_PS_CTRL_Crf_Size_BitField_MaxValue ((1u << 6) - 1)
#define Reg_PS_CTRL_And_V_Mask_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CTRL_Rd_Mode_BitField_MaxValue ((1u << 2) - 1)
#define Reg_PS_CTRL_Fp_Mode_BitField_MaxValue ((1u << 2) - 1)
#define Reg_PS_CTRL_Denorm_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CTRL_Thread_Mode_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CTRL_Cust_Blend_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CTRL_Rov_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_CTRL_Cust_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_PS_CTRL_Reserved_BitField_MaxValue ((1u << 11) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Crf_Size                  : 6;   
        unsigned int And_V_Mask                : 1;   
        unsigned int Rd_Mode                   : 2;   
        unsigned int Fp_Mode                   : 2;   
        unsigned int Denorm_En                 : 1;   
        unsigned int Thread_Mode               : 1;   
        unsigned int Cust_Blend_En             : 1;   
        unsigned int Rov_En                    : 1;   
        unsigned int Cust_Crf_Addr             : 6;   
        unsigned int Reserved                  : 11;  
    } reg;
} Reg_Ps_Ctrl;
 
#define Reg_PS_OUT_CFG_Clr_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Z_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Alpha_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Stencil_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Mask_Out_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Dual_Src_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_CFG_Clr_Out_Num_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_CFG_Z_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_CFG_Dual_Src_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_CFG_Mask_Out_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_CFG_Reserved_BitField_MaxValue ((1u << 11) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Clr_Out_En                : 1;   
        unsigned int Z_Out_En                  : 1;   
        unsigned int Alpha_Out_En              : 1;   
        unsigned int Stencil_Out_En            : 1;   
        unsigned int Mask_Out_En               : 1;   
        unsigned int Dual_Src_En               : 1;   
        unsigned int Clr_Out_Num               : 4;   
        unsigned int Z_Data_Fmt                : 4;   
        unsigned int Dual_Src_Fmt              : 4;   
        unsigned int Mask_Out_Mode             : 3;   
        unsigned int Reserved                  : 11;  
    } reg;
} Reg_Ps_Out_Cfg;
 
#define Reg_PS_DOUTBUF_CFG_Zl3_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_DOUTBUF_CFG_Clr_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_DOUTBUF_CFG_Reserved_BitField_MaxValue ((1u << 24) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Zl3_Size                  : 4;   
        unsigned int Clr_Size                  : 4;   
        unsigned int Reserved                  : 24;  
    } reg;
} Reg_Ps_Doutbuf_Cfg;
 
#define Reg_PS_PM_CFG_Pm_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_PM_CFG_Th_Pm_Size_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_PM_CFG_Reserved_BitField_MaxValue ((1u << 27) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Pm_En                     : 1;   
        unsigned int Th_Pm_Size                : 4;   
        unsigned int Reserved                  : 27;  
    } reg;
} Reg_Ps_Pm_Cfg;
 
#define Reg_PS_PM_ID_Pm_U_Id_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Pm_U_Id                   : 32;  
    } reg;
} Reg_Ps_Pm_Id;
 
#define Reg_PS_PM_RANGE_Ps_Idx_Ele_Range_BitField_MaxValue ((1u << 14) - 1)
#define Reg_PS_PM_RANGE_Reserved_BitField_MaxValue ((1u << 18) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ps_Idx_Ele_Range          : 14;  
        unsigned int Reserved                  : 18;  
    } reg;
} Reg_Ps_Pm_Range;
 
#define Reg_PS_OUT_MAPPING_O0_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O0_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O1_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O1_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O2_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O2_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O3_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O3_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O4_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O4_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O5_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O5_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O6_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O6_Addr_BitField_MaxValue ((1u << 3) - 1)
#define Reg_PS_OUT_MAPPING_O7_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_OUT_MAPPING_O7_Addr_BitField_MaxValue ((1u << 3) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int O0_En                     : 1;   
        unsigned int O0_Addr                   : 3;  
        unsigned int O1_En                     : 1;  
        unsigned int O1_Addr                   : 3;  
        unsigned int O2_En                     : 1;  
        unsigned int O2_Addr                   : 3;  
        unsigned int O3_En                     : 1;  
        unsigned int O3_Addr                   : 3;  
        unsigned int O4_En                     : 1;  
        unsigned int O4_Addr                   : 3;  
        unsigned int O5_En                     : 1;  
        unsigned int O5_Addr                   : 3;  
        unsigned int O6_En                     : 1;  
        unsigned int O6_Addr                   : 3;  
        unsigned int O7_En                     : 1;  
        unsigned int O7_Addr                   : 3;  
    } reg;
} Reg_Ps_Out_Mapping;
 
#define Reg_PS_OUT_RTFMT_Rt0_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt1_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt2_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt3_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt4_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt5_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt6_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_OUT_RTFMT_Rt7_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int O0_Data_Fmt : 4;   
        unsigned int O1_Data_Fmt : 4;   
        unsigned int O2_Data_Fmt : 4;   
        unsigned int O3_Data_Fmt : 4;   
        unsigned int O4_Data_Fmt : 4;   
        unsigned int O5_Data_Fmt : 4;   
        unsigned int O6_Data_Fmt : 4;   
        unsigned int O7_Data_Fmt : 4;   
    } reg;
} Reg_Ps_Out_Fmt;

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Rt0_Data_Fmt              : 4;  
        unsigned int Rt1_Data_Fmt              : 4;  
        unsigned int Rt2_Data_Fmt              : 4;  
        unsigned int Rt3_Data_Fmt              : 4;  
        unsigned int Rt4_Data_Fmt              : 4;  
        unsigned int Rt5_Data_Fmt              : 4;  
        unsigned int Rt6_Data_Fmt              : 4;  
        unsigned int Rt7_Data_Fmt              : 4;  
    } reg;
} Reg_Ps_Out_Rtfmt;

#define Reg_PS_U_ENABLE_U0_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U1_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U2_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U3_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U4_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U5_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U6_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U7_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U8_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U9_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U10_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U11_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U12_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U13_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U14_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U15_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U16_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U17_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U18_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U19_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U20_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U21_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U22_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U23_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U24_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U25_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U26_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U27_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U28_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U29_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U30_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_ENABLE_U31_En_BitField_MaxValue ((1u << 1) - 1)

 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int U0_En                     : 1;   
        unsigned int U1_En                     : 1;   
        unsigned int U2_En                     : 1;   
        unsigned int U3_En                     : 1;   
        unsigned int U4_En                     : 1;   
        unsigned int U5_En                     : 1;   
        unsigned int U6_En                     : 1;   
        unsigned int U7_En                     : 1;   
        unsigned int U8_En                     : 1;   
        unsigned int U9_En                     : 1;   
        unsigned int U10_En                    : 1;   
        unsigned int U11_En                    : 1;   
        unsigned int U12_En                    : 1;   
        unsigned int U13_En                    : 1;   
        unsigned int U14_En                    : 1;   
        unsigned int U15_En                    : 1;   
        unsigned int U16_En                    : 1;   
        unsigned int U17_En                    : 1;   
        unsigned int U18_En                    : 1;   
        unsigned int U19_En                    : 1;   
        unsigned int U20_En                    : 1;   
        unsigned int U21_En                    : 1;   
        unsigned int U22_En                    : 1;   
        unsigned int U23_En                    : 1;   
        unsigned int U24_En                    : 1;   
        unsigned int U25_En                    : 1;   
        unsigned int U26_En                    : 1;   
        unsigned int U27_En                    : 1;   
        unsigned int U28_En                    : 1;   
        unsigned int U29_En                    : 1;   
        unsigned int U30_En                    : 1;   
        unsigned int U31_En                    : 1;   
    } reg;
} Reg_Ps_U_Enable;
 
#define Reg_PS_U_FMT_U0_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U1_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U2_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U3_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U4_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U5_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U6_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)
#define Reg_PS_U_FMT_U7_Data_Fmt_BitField_MaxValue ((1u << 4) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int U0_Data_Fmt               : 4;   
        unsigned int U1_Data_Fmt               : 4;   
        unsigned int U2_Data_Fmt               : 4;   
        unsigned int U3_Data_Fmt               : 4;   
        unsigned int U4_Data_Fmt               : 4;   
        unsigned int U5_Data_Fmt               : 4;   
        unsigned int U6_Data_Fmt               : 4;   
        unsigned int U7_Data_Fmt               : 4;   
    } reg;
} Reg_Ps_U_Fmt;
 
#define Reg_PS_U_LAYOUT_U0_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U1_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U2_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U3_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U4_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U5_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U6_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U7_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U8_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U9_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U10_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U11_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U12_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U13_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U14_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U15_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U16_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U17_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U18_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U19_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U20_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U21_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U22_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U23_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U24_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U25_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U26_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U27_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U28_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U29_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U30_Layout_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_LAYOUT_U31_Layout_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int U0_Layout                 : 1;   
        unsigned int U1_Layout                 : 1;   
        unsigned int U2_Layout                 : 1;   
        unsigned int U3_Layout                 : 1;   
        unsigned int U4_Layout                 : 1;   
        unsigned int U5_Layout                 : 1;   
        unsigned int U6_Layout                 : 1;   
        unsigned int U7_Layout                 : 1;   
        unsigned int U8_Layout                 : 1;   
        unsigned int U9_Layout                 : 1;   
        unsigned int U10_Layout                : 1;   
        unsigned int U11_Layout                : 1;   
        unsigned int U12_Layout                : 1;   
        unsigned int U13_Layout                : 1;   
        unsigned int U14_Layout                : 1;   
        unsigned int U15_Layout                : 1;   
        unsigned int U16_Layout                : 1;   
        unsigned int U17_Layout                : 1;   
        unsigned int U18_Layout                : 1;   
        unsigned int U19_Layout                : 1;   
        unsigned int U20_Layout                : 1;   
        unsigned int U21_Layout                : 1;   
        unsigned int U22_Layout                : 1;   
        unsigned int U23_Layout                : 1;   
        unsigned int U24_Layout                : 1;   
        unsigned int U25_Layout                : 1;   
        unsigned int U26_Layout                : 1;   
        unsigned int U27_Layout                : 1;   
        unsigned int U28_Layout                : 1;   
        unsigned int U29_Layout                : 1;   
        unsigned int U30_Layout                : 1;   
        unsigned int U31_Layout                : 1;   
    } reg;
} Reg_Ps_U_Layout;
 
#define Reg_PS_U_CFG_Ps_U_Range_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PS_U_CFG_Rt0_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt1_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt2_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt3_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt4_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt5_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt6_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Rt7_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_PS_U_CFG_Reserved_BitField_MaxValue ((1u << 16) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ps_U_Range : 8;  
        unsigned int Rt0_En : 1;  
        unsigned int Rt1_En : 1;  
        unsigned int Rt2_En : 1;  
        unsigned int Rt3_En : 1;  
        unsigned int Rt4_En : 1;  
        unsigned int Rt5_En : 1;  
        unsigned int Rt6_En : 1;  
        unsigned int Rt7_En : 1;  
        unsigned int Reserved : 16;  
    } reg_CHX004;
    struct
    {
        unsigned int Ps_U_Range : 8;   
        unsigned int Reserved : 24;  
    } reg;
} Reg_Ps_U_Cfg;

 
#define Reg_PS_INSTR0_Address_Low_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Address_Low               : 32;  
    } reg;
} Reg_Ps_Instr0;
 
#define Reg_PS_INSTR1_Address_High_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PS_INSTR1_Reserved_BitField_MaxValue ((1u << 24) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Address_High              : 8;   
        unsigned int Reserved                  : 24;  
    } reg;
} Reg_Ps_Instr1;
 
#define Reg_PS_INSTR_RANGE_Ins_Range_BitField_MaxValue ((1u << 16) - 1)
#define Reg_PS_INSTR_RANGE_Reserved_BitField_MaxValue ((1u << 16) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ins_Range                 : 16;  
        unsigned int Reserved                  : 16;  
    } reg;
} Reg_Ps_Instr_Range;
 
#define Reg_PS_CB_CFG_Ps_Cb_Range_BitField_MaxValue ((1u << 9) - 1)
#define Reg_PS_CB_CFG_Reserved_BitField_MaxValue ((1u << 23) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ps_Cb_Range               : 9;   
        unsigned int Reserved                  : 23;  
    } reg;
} Reg_Ps_Cb_Cfg;
 
#define Reg_PS_REV_8ALIGNED_Reserved_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved                  : 32;  
    } reg;
} Reg_Ps_Rev_8aligned;
 
#define Reg_PS_REV_CB_Reserved_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved                  : 32;  
    } reg;
} Reg_Ps_Rev_Cb;
 
#define Reg_PS_CB_DATA_Const_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Const                     : 32;  
    } reg;
} Reg_Ps_Cb_Data;

typedef struct _Eu_Ps_regs 
{
    Reg_Ps_Cfg                       reg_Ps_Cfg;
    Reg_Ps_Ctrl                      reg_Ps_Ctrl;
    Reg_Ps_Out_Cfg                   reg_Ps_Out_Cfg;
    Reg_Ps_Doutbuf_Cfg               reg_Ps_Doutbuf_Cfg;
    Reg_Ps_Pm_Cfg                    reg_Ps_Pm_Cfg;
    Reg_Ps_Pm_Id                     reg_Ps_Pm_Id;
    Reg_Ps_Pm_Range                  reg_Ps_Pm_Range;
    Reg_Ps_Out_Mapping               reg_Ps_Out_Mapping;
    union
    {
        Reg_Ps_Out_Rtfmt                 reg_Ps_Out_Rtfmt;
        Reg_Ps_Out_Fmt                   reg_Ps_Out_Fmt;
    };
    Reg_Ps_U_Enable                  reg_Ps_U_Enable[2];
    Reg_Ps_U_Fmt                     reg_Ps_U_Fmt[8];
    Reg_Ps_U_Layout                  reg_Ps_U_Layout[2];
    Reg_Ps_U_Cfg                     reg_Ps_U_Cfg;
    Reg_Ps_Instr0                    reg_Ps_Instr0;
    Reg_Ps_Instr1                    reg_Ps_Instr1;
    Reg_Ps_Instr_Range               reg_Ps_Instr_Range;
    Reg_Ps_Cb_Cfg                    reg_Ps_Cb_Cfg;
    Reg_Ps_Rev_8aligned              reg_Ps_Rev_8aligned[6];
    Reg_Ps_Rev_Cb                    reg_Ps_Rev_Cb[224];
    Reg_Ps_Cb_Data                   reg_Ps_Cb_Data[2048];
} Eu_Ps_regs;

#endif
