#ifndef _IU_REGISTER_H
#define _IU_REGISTER_H


#ifndef        IU_BLOCKBASE_INF
    #define    IU_BLOCKBASE_INF
    #define    BLOCK_IU_VERSION 1 
    #define    BLOCK_IU_TIMESTAMP "14:22 2019-10-18"
    #define    IU_BLOCK                                           0x7 
    #define    IU_REG_START                                       0x0 
    #define    IU_REG_END_CHX004                                  0x48 
    #define    IU_REG_LIMIT_CHX004                                0x48 
    #define    IU_REG_END_Elt3k                                   0x40 
    #define    IU_REG_LIMIT_Elt3k                                 0x40 
#endif

#define        Reg_Iu_Ctrl_Offset                                         0x0
#define        Reg_Iu_Ctrl_Ex_Offset                                      0x1
#define        Reg_Iu_Rt_Size_Offset                                      0x2
#define        Reg_Iu_Mapping_Offset                                      0x3
#define        Reg_Iu_Intp_Mode_Offset                                    0xd
#define        Reg_Iu_Clip_Distance_Offset                                0x12
#define        Reg_Iu_Crf_Baseaddr_Offset                                 0x14
#define        Reg_Iu_Pxpy_Crf_Baseaddr_Offset                            0x1e
#define        Reg_Iu_Pxpy_Lowhigh_Offset                                 0x28
#define        Reg_Iu_Output_Format_Offset                                0x2a
#define        Reg_Iu_Viewportzvalue_Offset                               0x2c
#define        Reg_Iu_Builtin_Attr_Packing_Offset                         0x3c
#define        Reg_Iu_Reserved_Dw_Offset_Elt3k                            0x3d
#define        Reg_Programmable_Msaa_Pattern_Offset_CHX004                0x3d
#define        Reg_Iu_Ctrl_Ex2_Offset_CHX004                              0x41
#define        Reg_Iu_Reserved_Dw_Offset_CHX004                           0x42

typedef enum
{
    IU_CTRL_INSERT_POS_DISABLED              = 0, 
    IU_CTRL_INSERT_POS_ENABLED               = 1, 
} IU_CTRL_INSERT_POS;

typedef enum
{
    IU_CTRL_INSERT_FACE_DISABLED             = 0, 
    IU_CTRL_INSERT_FACE_ENABLED              = 1, 
} IU_CTRL_INSERT_FACE;

typedef enum
{
    IU_CTRL_INSERT_ARRAY_ID_DISABLE          = 0, 
    IU_CTRL_INSERT_ARRAY_ID_ENABLED          = 1, 
} IU_CTRL_INSERT_ARRAY_ID;

typedef enum
{
    IU_CTRL_INSERT_RASTER_MASK_DISABLED      = 0, 
    IU_CTRL_INSERT_RASTER_MASK_ENABLED       = 1,
} IU_CTRL_INSERT_RASTER_MASK;

typedef enum
{
    IU_CTRL_INSERT_SAMPLE_ID_DISABLED        = 0, 
    IU_CTRL_INSERT_SAMPLE_ID_ENABLED         = 1,
} IU_CTRL_INSERT_SAMPLE_ID;

typedef enum
{
    IU_CTRL_INSERT_SAMPLE_OFFSET_DISABLED    = 0, 
    IU_CTRL_INSERT_SAMPLE_OFFSET_ENABLED     = 1,
} IU_CTRL_INSERT_SAMPLE_OFFSET;

typedef enum
{
    IU_CTRL_INSERT_CONSERVATIVE_INNER_MASK_DISABLED= 0, 
    IU_CTRL_INSERT_CONSERVATIVE_INNER_MASK_ENABLED= 1, 
} IU_CTRL_INSERT_CONSERVATIVE_INNER_MASK;

typedef enum
{
    IU_CTRL_QUAD_2X2_MODE_EN_4X1             = 0, 
    IU_CTRL_QUAD_2X2_MODE_EN_2X2             = 1, 
} IU_CTRL_QUAD_2X2_MODE_EN;

typedef enum
{
    IU_CTRL_RAST_RULE_TOP_LEFT               = 0, 
    IU_CTRL_RAST_RULE_BOTTOM_LEFT            = 1, 
    IU_CTRL_RAST_RULE_TOP_RIGHT              = 2, 
    IU_CTRL_RAST_RULE_BOTTOM_RIGHT           = 3, 
} IU_CTRL_RAST_RULE;

typedef enum
{
    IU_CTRL_SIMD_MODE_SIMD32                 = 0, 
    IU_CTRL_SIMD_MODE_SIMD64                 = 1, 
} IU_CTRL_SIMD_MODE;

typedef enum
{
    IU_CTRL_EX_EU_BLENDING_EN_DISABLED       = 0, 
    IU_CTRL_EX_EU_BLENDING_EN_ENABLED        = 1, 
} IU_CTRL_EX_EU_BLENDING_EN;

typedef enum
{
    IU_CTRL_EX_Y_INVERT_EN_DISABLED          = 0, 
    IU_CTRL_EX_Y_INVERT_EN_ENABLED           = 1, 
} IU_CTRL_EX_Y_INVERT_EN;

typedef enum
{
    IU_CTRL_EX_PRE_ROTATE_EN_DISABLED        = 0, 
    IU_CTRL_EX_PRE_ROTATE_EN_ENABLED         = 1, 
} IU_CTRL_EX_PRE_ROTATE_EN;

typedef enum
{
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_0         = 0, 
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_90        = 1, 
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_90_H      = 2, 
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_90_V      = 3, 
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_180       = 4, 
    IU_CTRL_EX_PRE_ROTATE_TYPE_CCW_270       = 5, 
} IU_CTRL_EX_PRE_ROTATE_TYPE;

typedef enum
{
    IU_CTRL_EX_RAST_RESOLUTION_MSAA_1X       = 0, 
    IU_CTRL_EX_RAST_RESOLUTION_MSAA_2X       = 1, 
    IU_CTRL_EX_RAST_RESOLUTION_MSAA_4X       = 2, 
    IU_CTRL_EX_RAST_RESOLUTION_MSAA_8X       = 3, 
    IU_CTRL_EX_RAST_RESOLUTION_MSAA_16X      = 4, 
} IU_CTRL_EX_RAST_RESOLUTION;

typedef enum
{
    IU_CTRL_EX_API_VERSION_OGL               = 0, 
    IU_CTRL_EX_API_VERSION_DX9               = 1, 
    IU_CTRL_EX_API_VERSION_DX10              = 2, 
    IU_CTRL_EX_API_VERSION_DX11              = 3, 
    IU_CTRL_EX_API_VERSION_DX12              = 4, 
} IU_CTRL_EX_API_VERSION;

typedef enum
{
    IU_CTRL_EX_MSAA_EN_MSAA_OFF              = 0, 
    IU_CTRL_EX_MSAA_EN_MSAA_DEFAULT          = 1, 
    IU_CTRL_EX_MSAA_EN_MSAA_PROGRAMMABLE     = 2, 
    IU_CTRL_EX_MSAA_EN_MSAA_CENTER_SAMPLE    = 3, 
} IU_CTRL_EX_MSAA_EN;

typedef enum
{
    IU_CTRL_EX_MSAA_GRANULARITY_PER_PIXEL    = 0, 
    IU_CTRL_EX_MSAA_GRANULARITY_PER_QUAD     = 1, 
} IU_CTRL_EX_MSAA_GRANULARITY;

typedef enum
{
    IU_CTRL_EX_PS_SAMPLE_FREQUENCY_EN_DISABLED= 0, 
    IU_CTRL_EX_PS_SAMPLE_FREQUENCY_EN_ENABLED= 1, 
} IU_CTRL_EX_PS_SAMPLE_FREQUENCY_EN;

typedef enum
{
    IU_INTP_MODE_ATTR0_MODE_CENTER           = 0, 
    IU_INTP_MODE_ATTR0_MODE_SAMPLE           = 1, 
    IU_INTP_MODE_ATTR0_MODE_CENTROID         = 2, 
    IU_INTP_MODE_ATTR0_MODE_CONSTANT_NORMAL  = 3, 
    IU_INTP_MODE_ATTR0_MODE_CONSTANT_BYPASS  = 4, 
    IU_INTP_MODE_ATTR0_MODE_EU_INTP_PXPY     = 5, 
    IU_INTP_MODE_ATTR0_MODE_EU_INTP_PXINVPY  = 6, 
} IU_INTP_MODE_ATTR0_MODE;

typedef enum
{
    IU_CLIP_DISTANCE_ATTR0_CLIP_DISTANCE_EN_DISABLED= 0, 
    IU_CLIP_DISTANCE_ATTR0_CLIP_DISTANCE_EN_ENABLED= 1, 
} IU_CLIP_DISTANCE_ATTR0_CLIP_DISTANCE_EN;

typedef enum
{
    IU_PXPY_LOWHIGH_ATTR0_LOWHIGH_LOW_RG     = 0, 
    IU_PXPY_LOWHIGH_ATTR0_LOWHIGH_HIGH_BA    = 1, 
} IU_PXPY_LOWHIGH_ATTR0_LOWHIGH;

typedef enum
{
    IU_OUTPUT_FORMAT_ATTR0_FMT_FP            = 0, 
    IU_OUTPUT_FORMAT_ATTR0_FMT_HP            = 1, 
} IU_OUTPUT_FORMAT_ATTR0_FMT;

typedef enum
{
    IU_CTRL_EX2_RT_RESOLUTION_1X             = 0, 
    IU_CTRL_EX2_RT_RESOLUTION_2X             = 1, 
    IU_CTRL_EX2_RT_RESOLUTION_4X             = 2, 
    IU_CTRL_EX2_RT_RESOLUTION_8X             = 3, 
    IU_CTRL_EX2_RT_RESOLUTION_16X            = 4, 
} IU_CTRL_EX2_RT_RESOLUTION;

typedef enum
{
    IU_CTRL_EX2_ROV_EN_DISABLED              = 0, 
    IU_CTRL_EX2_ROV_EN_ENABLED               = 1, 
} IU_CTRL_EX2_ROV_EN;



#define Reg_IU_CTRL_Ps_Attr_Num_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CTRL_Ab_Attr_Num_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CTRL_Insert_Pos_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Face_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Array_Id_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Raster_Mask_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Sample_Id_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Sample_Offset_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Insert_Conservative_Inner_Mask_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Pack_Z_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Pack_W_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Quad_2x2_Mode_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Rast_Rule_BitField_MaxValue ((1u << 2) - 1)
#define Reg_IU_CTRL_Rule_For_Msaa_Line_BitField_MaxValue ((1u << 2) - 1)
#define Reg_IU_CTRL_Rule_For_A_Line_BitField_MaxValue ((1u << 2) - 1)
#define Reg_IU_CTRL_Simd_Mode_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Pack_Face_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Pack_Sample_Id_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_Post_Depth_Coverage_En_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Ps_Attr_Num               : 6;  
        unsigned int Ab_Attr_Num               : 6;  
        unsigned int Insert_Pos                : 1;  
        unsigned int Insert_Face               : 1;  
        unsigned int Insert_Array_Id           : 1;  
        unsigned int Insert_Raster_Mask        : 1;  
        unsigned int Insert_Sample_Id          : 1;  
        unsigned int Insert_Sample_Offset      : 1;  
        unsigned int Insert_Conservative_Inner_Mask: 1;  
        unsigned int Pack_Z                    : 1;  
        unsigned int Pack_W                    : 1;  
        unsigned int Quad_2x2_Mode_En          : 1;  
        unsigned int Rast_Rule                 : 2;  
        unsigned int Rule_For_Msaa_Line        : 2;  
        unsigned int Rule_For_A_Line           : 2;  
        unsigned int Simd_Mode                 : 1;  
        unsigned int Pack_Face                 : 1;  
        unsigned int Pack_Sample_Id            : 1;  
        unsigned int Post_Depth_Coverage_En    : 1;  
    } reg;
} Reg_Iu_Ctrl;

#define Reg_IU_CTRL_EX_Eu_Blending_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Y_Invert_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Pre_Rotate_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Pre_Rotate_Type_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_CTRL_EX_Rast_Resolution_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_CTRL_EX_Api_Version_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_CTRL_EX_Pixel_Center_Integer_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Fragcoord_Invert_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Msaa_Center_Sample_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Mrt_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_First_Valid_Sample_BitField_MaxValue ((1u << 5) - 1)
#define Reg_IU_CTRL_EX_Insert_Shaing_Rate_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Force_Kickoff_Tile_Num_BitField_MaxValue ((1u << 5) - 1)
#define Reg_IU_CTRL_EX_Msaa_En_BitField_MaxValue ((1u << 2) - 1)
#define Reg_IU_CTRL_EX_Msaa_Granularity_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Ps_Sample_Frequency_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX_Reserved_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
	struct
	{
		unsigned int Eu_Blending_En : 1;  
		unsigned int Y_Invert_En : 1;  
		unsigned int Pre_Rotate_En : 1;  
		unsigned int Pre_Rotate_Type : 3;  
		unsigned int Rast_Resolution : 3;  
		unsigned int Api_Version : 3;  
		unsigned int Pixel_Center_Integer_En : 1;  
		unsigned int Fragcoord_Invert_En : 1;  
		unsigned int Msaa_Center_Sample_En : 1;  
		unsigned int Mrt_En : 1;  
		unsigned int First_Valid_Sample : 5;  
		unsigned int Insert_Shaing_Rate : 1;  
		unsigned int Force_Kickoff_Tile_Num : 5;  
		unsigned int Msaa_En : 2;  
		unsigned int Msaa_Granularity : 1;  
		unsigned int Ps_Sample_Frequency_En : 1;  
		unsigned int Reserved : 1;  
	} reg_CHX004;
	struct
	{
		unsigned int Eu_Blending_En : 1;   
		unsigned int Y_Invert_En : 1;   
		unsigned int Pre_Rotate_En : 1;   
		unsigned int Pre_Rotate_Type : 3;   
		unsigned int Rast_Resolution : 3;   
		unsigned int Api_Version : 3;   
		unsigned int Pixel_Center_Integer_En : 1;   
		unsigned int Fragcoord_Invert_En : 1;   
		unsigned int Msaa_Center_Sample_En : 1;   
		unsigned int Mrt_En : 1;   
		unsigned int First_Valid_Sample : 5;   
		unsigned int Reserved : 11;  
	} reg;
} Reg_Iu_Ctrl_Ex;

#define Reg_IU_RT_SIZE_Rt_Height_BitField_MaxValue ((1u << 15) - 1)
#define Reg_IU_RT_SIZE_Rt_Width_BitField_MaxValue ((1u << 15) - 1)
#define Reg_IU_RT_SIZE_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Rt_Height                 : 15;  
        unsigned int Rt_Width                  : 15;  
        unsigned int Reserved                  : 2;  
    } reg;
} Reg_Iu_Rt_Size;

#define Reg_IU_MAPPING_Attr0_Id_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_MAPPING_Attr1_Id_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_MAPPING_Attr2_Id_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_MAPPING_Attr3_Id_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_MAPPING_Attr4_Id_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_MAPPING_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Id                  : 6;  
        unsigned int Attr1_Id                  : 6;  
        unsigned int Attr2_Id                  : 6;  
        unsigned int Attr3_Id                  : 6;  
        unsigned int Attr4_Id                  : 6;  
        unsigned int Reserved                  : 2;  
    } reg;
} Reg_Iu_Mapping;

#define Reg_IU_INTP_MODE_Attr0_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr1_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr2_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr3_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr4_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr5_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr6_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr7_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr8_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Attr9_Mode_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_INTP_MODE_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Mode                : 3;  
        unsigned int Attr1_Mode                : 3;  
        unsigned int Attr2_Mode                : 3;  
        unsigned int Attr3_Mode                : 3;  
        unsigned int Attr4_Mode                : 3;  
        unsigned int Attr5_Mode                : 3;  
        unsigned int Attr6_Mode                : 3;  
        unsigned int Attr7_Mode                : 3;  
        unsigned int Attr8_Mode                : 3;  
        unsigned int Attr9_Mode                : 3;  
        unsigned int Reserved                  : 2;  
    } reg;
} Reg_Iu_Intp_Mode;

#define Reg_IU_CLIP_DISTANCE_Attr0_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr1_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr2_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr3_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr4_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr5_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr6_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr7_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr8_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr9_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr10_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr11_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr12_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr13_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr14_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr15_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr16_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr17_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr18_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr19_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr20_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr21_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr22_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr23_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr24_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr25_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr26_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr27_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr28_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr29_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr30_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CLIP_DISTANCE_Attr31_Clip_Distance_En_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Clip_Distance_En    : 1;  
        unsigned int Attr1_Clip_Distance_En    : 1;  
        unsigned int Attr2_Clip_Distance_En    : 1;  
        unsigned int Attr3_Clip_Distance_En    : 1;  
        unsigned int Attr4_Clip_Distance_En    : 1;  
        unsigned int Attr5_Clip_Distance_En    : 1;  
        unsigned int Attr6_Clip_Distance_En    : 1;  
        unsigned int Attr7_Clip_Distance_En    : 1;  
        unsigned int Attr8_Clip_Distance_En    : 1;  
        unsigned int Attr9_Clip_Distance_En    : 1;  
        unsigned int Attr10_Clip_Distance_En   : 1;  
        unsigned int Attr11_Clip_Distance_En   : 1;  
        unsigned int Attr12_Clip_Distance_En   : 1;  
        unsigned int Attr13_Clip_Distance_En   : 1;  
        unsigned int Attr14_Clip_Distance_En   : 1;  
        unsigned int Attr15_Clip_Distance_En   : 1;  
        unsigned int Attr16_Clip_Distance_En   : 1;  
        unsigned int Attr17_Clip_Distance_En   : 1;  
        unsigned int Attr18_Clip_Distance_En   : 1;  
        unsigned int Attr19_Clip_Distance_En   : 1;  
        unsigned int Attr20_Clip_Distance_En   : 1;  
        unsigned int Attr21_Clip_Distance_En   : 1;  
        unsigned int Attr22_Clip_Distance_En   : 1;  
        unsigned int Attr23_Clip_Distance_En   : 1;  
        unsigned int Attr24_Clip_Distance_En   : 1;  
        unsigned int Attr25_Clip_Distance_En   : 1;  
        unsigned int Attr26_Clip_Distance_En   : 1;  
        unsigned int Attr27_Clip_Distance_En   : 1;  
        unsigned int Attr28_Clip_Distance_En   : 1;  
        unsigned int Attr29_Clip_Distance_En   : 1;  
        unsigned int Attr30_Clip_Distance_En   : 1;  
        unsigned int Attr31_Clip_Distance_En   : 1;  
    } reg;
} Reg_Iu_Clip_Distance;

#define Reg_IU_CRF_BASEADDR_Attr0_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CRF_BASEADDR_Attr1_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CRF_BASEADDR_Attr2_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CRF_BASEADDR_Attr3_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CRF_BASEADDR_Attr4_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_CRF_BASEADDR_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Crf_Addr            : 6;  
        unsigned int Attr1_Crf_Addr            : 6;  
        unsigned int Attr2_Crf_Addr            : 6;  
        unsigned int Attr3_Crf_Addr            : 6;  
        unsigned int Attr4_Crf_Addr            : 6;  
        unsigned int Reserved                  : 2;  
    } reg;
} Reg_Iu_Crf_Baseaddr;

#define Reg_IU_PXPY_CRF_BASEADDR_Attr0_Pxpy_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_PXPY_CRF_BASEADDR_Attr1_Pxpy_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_PXPY_CRF_BASEADDR_Attr2_Pxpy_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_PXPY_CRF_BASEADDR_Attr3_Pxpy_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_PXPY_CRF_BASEADDR_Attr4_Pxpy_Crf_Addr_BitField_MaxValue ((1u << 6) - 1)
#define Reg_IU_PXPY_CRF_BASEADDR_Reserved_BitField_MaxValue ((1u << 2) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Pxpy_Crf_Addr       : 6;  
        unsigned int Attr1_Pxpy_Crf_Addr       : 6;  
        unsigned int Attr2_Pxpy_Crf_Addr       : 6;  
        unsigned int Attr3_Pxpy_Crf_Addr       : 6;  
        unsigned int Attr4_Pxpy_Crf_Addr       : 6;  
        unsigned int Reserved                  : 2;  
    } reg;
} Reg_Iu_Pxpy_Crf_Baseaddr;

#define Reg_IU_PXPY_LOWHIGH_Attr0_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr1_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr2_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr3_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr4_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr5_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr6_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr7_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr8_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr9_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr10_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr11_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr12_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr13_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr14_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr15_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr16_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr17_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr18_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr19_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr20_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr21_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr22_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr23_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr24_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr25_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr26_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr27_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr28_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr29_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr30_Lowhigh_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_PXPY_LOWHIGH_Attr31_Lowhigh_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Lowhigh             : 1;  
        unsigned int Attr1_Lowhigh             : 1;  
        unsigned int Attr2_Lowhigh             : 1;  
        unsigned int Attr3_Lowhigh             : 1;  
        unsigned int Attr4_Lowhigh             : 1;  
        unsigned int Attr5_Lowhigh             : 1;  
        unsigned int Attr6_Lowhigh             : 1;  
        unsigned int Attr7_Lowhigh             : 1;  
        unsigned int Attr8_Lowhigh             : 1;  
        unsigned int Attr9_Lowhigh             : 1;  
        unsigned int Attr10_Lowhigh            : 1;  
        unsigned int Attr11_Lowhigh            : 1;  
        unsigned int Attr12_Lowhigh            : 1;  
        unsigned int Attr13_Lowhigh            : 1;  
        unsigned int Attr14_Lowhigh            : 1;  
        unsigned int Attr15_Lowhigh            : 1;  
        unsigned int Attr16_Lowhigh            : 1;  
        unsigned int Attr17_Lowhigh            : 1;  
        unsigned int Attr18_Lowhigh            : 1;  
        unsigned int Attr19_Lowhigh            : 1;  
        unsigned int Attr20_Lowhigh            : 1;  
        unsigned int Attr21_Lowhigh            : 1;  
        unsigned int Attr22_Lowhigh            : 1;  
        unsigned int Attr23_Lowhigh            : 1;  
        unsigned int Attr24_Lowhigh            : 1;  
        unsigned int Attr25_Lowhigh            : 1;  
        unsigned int Attr26_Lowhigh            : 1;  
        unsigned int Attr27_Lowhigh            : 1;  
        unsigned int Attr28_Lowhigh            : 1;  
        unsigned int Attr29_Lowhigh            : 1;  
        unsigned int Attr30_Lowhigh            : 1;  
        unsigned int Attr31_Lowhigh            : 1;  
    } reg;
} Reg_Iu_Pxpy_Lowhigh;

#define Reg_IU_OUTPUT_FORMAT_Attr0_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr1_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr2_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr3_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr4_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr5_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr6_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr7_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr8_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr9_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr10_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr11_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr12_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr13_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr14_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr15_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr16_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr17_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr18_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr19_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr20_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr21_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr22_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr23_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr24_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr25_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr26_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr27_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr28_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr29_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr30_Fmt_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_OUTPUT_FORMAT_Attr31_Fmt_BitField_MaxValue ((1u << 1) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Attr0_Fmt                 : 1;  
        unsigned int Attr1_Fmt                 : 1;  
        unsigned int Attr2_Fmt                 : 1;  
        unsigned int Attr3_Fmt                 : 1;  
        unsigned int Attr4_Fmt                 : 1;  
        unsigned int Attr5_Fmt                 : 1;  
        unsigned int Attr6_Fmt                 : 1;  
        unsigned int Attr7_Fmt                 : 1;  
        unsigned int Attr8_Fmt                 : 1;  
        unsigned int Attr9_Fmt                 : 1;  
        unsigned int Attr10_Fmt                : 1;  
        unsigned int Attr11_Fmt                : 1;  
        unsigned int Attr12_Fmt                : 1;  
        unsigned int Attr13_Fmt                : 1;  
        unsigned int Attr14_Fmt                : 1;  
        unsigned int Attr15_Fmt                : 1;  
        unsigned int Attr16_Fmt                : 1;  
        unsigned int Attr17_Fmt                : 1;  
        unsigned int Attr18_Fmt                : 1;  
        unsigned int Attr19_Fmt                : 1;  
        unsigned int Attr20_Fmt                : 1;  
        unsigned int Attr21_Fmt                : 1;  
        unsigned int Attr22_Fmt                : 1;  
        unsigned int Attr23_Fmt                : 1;  
        unsigned int Attr24_Fmt                : 1;  
        unsigned int Attr25_Fmt                : 1;  
        unsigned int Attr26_Fmt                : 1;  
        unsigned int Attr27_Fmt                : 1;  
        unsigned int Attr28_Fmt                : 1;  
        unsigned int Attr29_Fmt                : 1;  
        unsigned int Attr30_Fmt                : 1;  
        unsigned int Attr31_Fmt                : 1;  
    } reg;
} Reg_Iu_Output_Format;

#define Reg_IU_VIEWPORTZVALUE_Viewportzmin_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Viewportzmin              : 32;  
    } reg;
} Reg_Iu_Viewportzvalue;

#define Reg_IU_BUILTIN_ATTR_PACKING_Faceid_Dst_Crfaddr_BitField_MaxValue ((1u << 9) - 1)
#define Reg_IU_BUILTIN_ATTR_PACKING_Sampleid_Dst_Crfaddr_BitField_MaxValue ((1u << 9) - 1)
#define Reg_IU_BUILTIN_ATTR_PACKING_Reserved_BitField_MaxValue ((1u << 14) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Faceid_Dst_Crfaddr        : 9;  
        unsigned int Sampleid_Dst_Crfaddr      : 9;  
        unsigned int Reserved                  : 14;  
    } reg;
} Reg_Iu_Builtin_Attr_Packing;

#define Reg_PROGRAMMABLE_MSAA_PATTERN_XY_S0_Xy_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PROGRAMMABLE_MSAA_PATTERN_XY_S1_Xy_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PROGRAMMABLE_MSAA_PATTERN_XY_S2_Xy_BitField_MaxValue ((1u << 8) - 1)
#define Reg_PROGRAMMABLE_MSAA_PATTERN_XY_S3_Xy_BitField_MaxValue ((1u << 8) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int S0_Xy                     : 8;
        unsigned int S1_Xy                     : 8;
        unsigned int S2_Xy                     : 8;
        unsigned int S3_Xy                     : 8;
    } reg;
} Reg_Programmable_Msaa_Pattern_Xy;



typedef struct _Group_Programmable_Msaa_Pattern
{
    Reg_Programmable_Msaa_Pattern_Xy reg_Programmable_Msaa_Pattern_Xy;
} Reg_Programmable_Msaa_Pattern_Group;

#define Reg_IU_CTRL_EX2_Tir_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX2_Rt_Resolution_BitField_MaxValue ((1u << 3) - 1)
#define Reg_IU_CTRL_EX2_Rov_En_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX2_Multi_Osharp_BitField_MaxValue ((1u << 1) - 1)
#define Reg_IU_CTRL_EX2_Reserved_BitField_MaxValue ((1u << 26) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Tir_En                    : 1;  
        unsigned int Rt_Resolution             : 3;  
        unsigned int Rov_En                    : 1;  
        unsigned int Multi_Osharp : 1;  
        unsigned int Reserved : 26;  
    } reg;
} Reg_Iu_Ctrl_Ex2;

#define Reg_IU_RESERVED_DW_Reserved_BitField_MaxValue ((1u << 32) - 1)

typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved                  : 32;  
    } reg;
} Reg_Iu_Reserved_Dw;

typedef struct _Iu_regs_CHX004
{
    Reg_Iu_Ctrl                      reg_Iu_Ctrl;
    Reg_Iu_Ctrl_Ex                   reg_Iu_Ctrl_Ex;
    Reg_Iu_Rt_Size                   reg_Iu_Rt_Size;
    Reg_Iu_Mapping                   reg_Iu_Mapping[10];
    Reg_Iu_Intp_Mode                 reg_Iu_Intp_Mode[5];
    Reg_Iu_Clip_Distance             reg_Iu_Clip_Distance[2];
    Reg_Iu_Crf_Baseaddr              reg_Iu_Crf_Baseaddr[10];
    Reg_Iu_Pxpy_Crf_Baseaddr         reg_Iu_Pxpy_Crf_Baseaddr[10];
    Reg_Iu_Pxpy_Lowhigh              reg_Iu_Pxpy_Lowhigh[2];
    Reg_Iu_Output_Format             reg_Iu_Output_Format[2];
    Reg_Iu_Viewportzvalue            reg_Iu_Viewportzvalue[16];
    Reg_Iu_Builtin_Attr_Packing      reg_Iu_Builtin_Attr_Packing;
    Reg_Programmable_Msaa_Pattern_Group
                                     reg_Programmable_Msaa_Pattern[4];
    Reg_Iu_Ctrl_Ex2                  reg_Iu_Ctrl_Ex2;
    Reg_Iu_Reserved_Dw               reg_Iu_Reserved_Dw[6];
} Iu_regs_CHX004;

typedef struct _Iu_regs
{
	Reg_Iu_Ctrl                      reg_Iu_Ctrl;
	Reg_Iu_Ctrl_Ex                   reg_Iu_Ctrl_Ex;
	Reg_Iu_Rt_Size                   reg_Iu_Rt_Size;
	Reg_Iu_Mapping                   reg_Iu_Mapping[10];
	Reg_Iu_Intp_Mode                 reg_Iu_Intp_Mode[5];
	Reg_Iu_Clip_Distance             reg_Iu_Clip_Distance[2];
	Reg_Iu_Crf_Baseaddr              reg_Iu_Crf_Baseaddr[10];
	Reg_Iu_Pxpy_Crf_Baseaddr         reg_Iu_Pxpy_Crf_Baseaddr[10];
	Reg_Iu_Pxpy_Lowhigh              reg_Iu_Pxpy_Lowhigh[2];
	Reg_Iu_Output_Format             reg_Iu_Output_Format[2];
	Reg_Iu_Viewportzvalue            reg_Iu_Viewportzvalue[16];
	Reg_Iu_Builtin_Attr_Packing      reg_Iu_Builtin_Attr_Packing;
	Reg_Iu_Reserved_Dw               reg_Iu_Reserved_Dw[3];
} Iu_regs;

#endif
