#ifndef _L2_REGISTER_H
#define _L2_REGISTER_H


#ifndef        L2_BLOCKBASE_INF
    #define    L2_BLOCKBASE_INF
    #define    BLOCK_L2_VERSION 1
    #define    BLOCK_L2_TIMESTAMP "2019/3/1 9:46:22"
    #define    L2_BLOCK                                                   0xB 
    #define    L2_REG_START                                               0x0 
    #define    L2_REG_END                                                 0x10 
    #define    L2_REG_LIMIT                                               0x10 
#endif

#define        Reg_Rb0_Offset                                             0x0
#define        Reg_Rb1_Offset                                             0x1
#define        Reg_Rb2_Offset                                             0x2
#define        Reg_Argument_Offset                                        0x3
#define        Reg_L2_Performance_Offset                                  0x4
#define        Reg_L2_Reserved_Offset                                     0x5
#define        Reg_L2_Reserved1_Offset                                    0xC


 
#define  Reg_Rb0_Reserved_0_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Rb0_Reserved_1_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_0                : 20;  
        unsigned int Reserved_1                : 12;  
    } reg;
} Reg_Rb0;
 
#define  Reg_Rb1_Reserved_0_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Rb1_Reserved_1_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_0                : 20;  
        unsigned int Reserved_1                : 12;  
    } reg;
} Reg_Rb1;
 
#define  Reg_Rb2_Reserved_0_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Rb2_Reserved_1_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_0                : 20;  
        unsigned int Reserved_1                : 12;  
    } reg;
} Reg_Rb2;
 
#define  Reg_Argument_Reserved_0_BitField_MaxValue ((1u << 20) - 1)
#define  Reg_Argument_Reserved_1_BitField_MaxValue ((1u << 12) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved_0                : 20;  
        unsigned int Reserved_1                : 12;  
    } reg;
} Reg_Argument;
 
#define  Reg_L2_Performance_L2_Dist_Ctrl_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_Reserved0_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_L2_Latency_Buf_Dist_Ctrl_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_Reserved1_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_L2_Slc_Osd_Num_Ctrl_BitField_MaxValue ((1u << 4) - 1)
#define  Reg_L2_Performance_L2_Tu_Block_By_Refcnt_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_L2_Fully_W_Opt_BitField_MaxValue ((1u << 1) - 1)
#define  Reg_L2_Performance_Reserved2_BitField_MaxValue ((1u << 22) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int L2_Dist_Ctrl              : 1;   
        unsigned int Reserved0                 : 1;   
        unsigned int L2_Latency_Buf_Dist_Ctrl : 1;    
        unsigned int Reserved1                 : 1;   
        unsigned int L2_Slc_Osd_Num_Ctrl       : 4;   
        unsigned int L2_Tu_Block_By_Refcnt     : 1;   
        unsigned int L2_Fully_W_Opt            : 1;   
        unsigned int Reserved2                 : 22;  
    } reg;
} Reg_L2_Performance;
 
#define  Reg_L2_Reserved_Reserved_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved                  : 32;  
    } reg;
} Reg_L2_Reserved;
 
#define  Reg_L2_Reserved1_Reserved_BitField_MaxValue ((1u << 32) - 1)
 
typedef union
{
    unsigned int uint;
    struct
    {
        unsigned int Reserved                  : 32;  
    } reg;
} Reg_L2_Reserved1;
 
typedef struct _L2_regs
{
    Reg_Rb0                          reg_Rb0;
    Reg_Rb1                          reg_Rb1;
    Reg_Rb2                          reg_Rb2;
    Reg_Argument                     reg_Argument;
    Reg_L2_Performance               reg_L2_Performance;
    Reg_L2_Reserved                  reg_L2_Reserved[7];
    Reg_L2_Reserved1                 reg_L2_Reserved1[4];
} L2_regs;

#endif
