#include "zx_adapter.h"
#include "vidsch.h"
#include "vidmm.h"
#include "context.h"
#include "global.h"

int pm_save_state(adapter_t *adapter, int need_save_memory)
{
    int ret = S_OK;
    ret = cm_save(adapter, need_save_memory);

    if (ret != S_OK)
    {
        return ret;
    }

    ret = vidsch_save(adapter);

    if (ret != S_OK)
    {
        return ret;
    }

    ret = vidmm_save(adapter);

    return ret;
    /* system will suspend, set our card mode as uninitialize */
}


//temp use only, will remove after resume stable.
static inline void util_print_time(char *info)
{
    long time_sec = 0, time_usec = 0;
    
    zx_getsecs(&time_sec, &time_usec);
    zx_info("%s %ld(ms)\n",info,(time_sec * 1000 + zx_do_div(time_usec, 1000)));
}

int pm_restore_state(adapter_t *adapter)
{  
    int ret = S_OK;

    //temp use only, will remove all this function called after resume stable.
    util_print_time("pm_restore_state enter, cur time");
    
    glb_init_chip_interface(adapter);
    util_print_time("glb_init_chip_interface finish, cur time");

    if(ret != S_OK)
    {
        zx_error("dispmgr restore error\n");
        return ret;
    }

    vidmm_restore(adapter);
    util_print_time("vidmm_restore finish, cur time");

    vidsch_restore(adapter);
    util_print_time("vidsch_restore finish, cur time");

    cm_restore(adapter);
    util_print_time("cm_restore finish, cur time");

    return ret;
}
