#ifndef __QUEUE_H_
#define __QUEUE_H_


#define QUEUE_SUCCESS 0
#define QUEUE_FAIL    1
#define QUEUE_FULL    2
#define QUEUE_EMPTY   3



typedef struct
{
    int  entry_num;
    int  entry_size;
    int  data_size;
    int  entry_inuse;
    int  start;
//    int  end;

    struct os_spinlock *lock;
    char *entrys;
}queue_t;

extern int  queue_init(queue_t *queue, int entry_num, int entry_size);
extern void queue_fini(queue_t *queue);
extern int  queue_add_entry(queue_t *queue, void *data);
extern int  queue_get_first_entry_and_free(queue_t *queue, void *data);
extern int  queue_get_entry(queue_t *queue, int num, void *data);
extern int  queue_get_first_entry(queue_t *queue, void *data);
extern int  queue_free_entry(queue_t *queue, int num);
extern void queue_query_info(queue_t *queue, int *start, int *inuse_num);

#endif /* __QUEUE_H_*/

