#include "zx_adapter.h"
#include "vidsch.h"
#include "vidschi.h"

int vidsch_query_dvfs_clamp(adapter_t *adapter, zx_dvfs_clamp_status_t* dvfs_clamp)
{
    vidschedule_t *schedule = adapter->schedule;
    int status = -1;
	
    if(schedule->chip_func->query_dvfs_clamp)
    {
        status = schedule->chip_func->query_dvfs_clamp(adapter, dvfs_clamp);
    }

    return status;
}


int vidsch_dvfs_set(adapter_t *adapter, zx_dvfs_set_t *dvfs_set)
{
    vidschedule_t *schedule = adapter->schedule;
    int status = -1;

    adapter->pm_caps.dvfs_force = dvfs_set->dvfs_force;

    if(adapter->pm_caps.dvfs_force && schedule->chip_func->set_dvfs)
    {
        status = schedule->chip_func->set_dvfs(adapter, dvfs_set);
    }

    return status;
}

void vidsch_try_dvfs_tuning(adapter_t *adapter)
{
    vidschedule_t *schedule = adapter->schedule;

    if(!adapter->pm_caps.dvfs_force && schedule->chip_func->dvfs_tuning)
    {
       schedule->chip_func->dvfs_tuning(adapter);
    }
}

