#ifndef ZX_CMODEL_MMIO_TYPES_H
#define ZX_CMODEL_MMIO_TYPES_H

#define NETLINK_USER    22
#define USER_MSG        (NETLINK_USER + 1)
#define USER_PORT       50
#define MSG_LEN 100
#define MAX_PLOAD 100

typedef union mmio_value
{
    unsigned char   value_8;
    unsigned short  value_16;
    unsigned int    value_32;
    unsigned long   value_64;
}mmio_value_t;

typedef struct mmio_result
{
    mmio_value_t value;
    int          responsed;
}mmio_result_t;

typedef struct mmio_msg
{
    int   read; //read or write
    int   width;
    unsigned long addr;
    mmio_value_t value;
}mmio_msg_t;

typedef struct netlink_msg
{
    struct nlmsghdr hdr;
    unsigned char data[MSG_LEN];
} netlink_msg_t;

#endif //ZX_CMODEL_MMIO_TYPTES_H


